//------------------------------------------------------------------------------
//fBAtB^SIMD
//------------------------------------------------------------------------------
/*
gcc 4.4.3ŃRpCmF
*/
#include <windows.h>
#include <mmintrin.h>
#include "filter.h"

#include "median_filter.h"

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 5
TCHAR *track_name[]   = { "", "O", "O", "O", "OE" };
int     track_default[] = { 1,    0,    0,    0,    0 };
int     track_s[]       = { 1,    0,    0,    0,    0 };
int     track_e[]       = { 8, 1024, 1024, 1024, 1024 };

#define CHECK_N 5
TCHAR *check_name[] = { "O͈͊mF", "͈͊mF", "SSE2(off:MMX)", "4ߖTŏ(off:8ߖT)",  "F" };
int check_default[] = { 0, 1, 1, 1, 1 };

FILTER_DLL filter = {
    FILTER_FLAG_EX_INFORMATION,
    0,0,
    "fBAtB^SIMD",
    TRACK_N,
    track_name,
    track_default,
    track_s,track_e,
    CHECK_N,
    check_name,
    check_default,
    func_proc,
    func_init,
    NULL,
    NULL,
    NULL,
    NULL,NULL,
    NULL,
    0,
    "fBAtB^ ver 1.0.1 by ۂ",
    NULL,
    NULL,
};

//---------------------------------------------------------------------
// SIMD̃tO
//---------------------------------------------------------------------
#define FLAG_MMX  0x800000
#define FLAG_SSE  0x2000000
#define FLAG_SSE2 0x4000000

static int g_simd_flag = 0;

__declspec(noinline) int cpuid_simd()
{
    int flag;
    __asm volatile (
        "movl $1,%%eax   \n"
        "cpuid           \n"
        "movl %%edx,%0   \n"
        : "=m" (flag)
        :
        : "%eax", "%ebx", "%ecx", "%edx" // 4ޔȂƃoO
    );
    return flag; 
}

//---------------------------------------------------------------------
// tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
    g_simd_flag = cpuid_simd(); // SIMD̃tOQbg
    return &filter;
}

//---------------------------------------------------------------------
// 
//---------------------------------------------------------------------
BOOL func_init( FILTER *fp )
{
    g_simd_flag = cpuid_simd(); // Ŏ擾Ă邪Ô

    // AviUtl̍Ɨ̈悪傫ꍇ̓gbNo[̍ől𒲐
    BOOL bUpdate = FALSE;
    SYS_INFO si;
    fp->exfunc->get_sys_info( NULL, &si );
    int max_size = (si.max_w > si.max_h) ? si.max_w : si.max_h;
    for( int i = MASK_TOP; i <= MASK_RIGHT; i++ )
    {
        if( max_size > fp->track_e[i] )
        {
            fp->track_e[i] = max_size;
            bUpdate = TRUE;
        } 
    }
    if( bUpdate ) fp->exfunc->filter_window_update( fp );

    return TRUE;
}

//---------------------------------------------------------------------
// short^464bit֕ϊ镔łxς̂
// 낢뎎悤Ƀ}N
//---------------------------------------------------------------------

// short^232bitɂ
#define MK_INT( A, B ) ( (int)(unsigned short)A | ((int)B << 16) )

// short^464bitɂ
//#define MK_M64( A, B, C, D ) _mm_setr_pi16( A, B, C, D )
//#define MK_M64( A, B, C, D ) _mm_setr_pi32( MK_INT( A, B ), MK_INT( C, D ) )
#define MK_M64( A, B, C, D ) _mm_or_si64( _m_from_int( MK_INT( A, B ) ), _m_psllqi( _m_from_int( MK_INT( C, D ) ), 32 ) )

//---------------------------------------------------------------------
// ׂēւȂ
//---------------------------------------------------------------------

#define MIN_MAX_MMX( A, B ) \
    { \
        const __m64 t = _mm_and_si64( _mm_xor_si64( A, B ), _mm_cmpgt_pi16( A, B ) ); \
        A = _mm_xor_si64( t, A ); \
        B = _mm_xor_si64( t, B ); \
    }

/*
// 
#define MIN_MAX_MMX( A, B ) \
    { \
        const __m64 mask = _mm_cmpgt_pi16( A, B ); \
        const __m64 max = _mm_or_si64( _mm_andnot_si64( mask, B ), _mm_and_si64( mask, A ) ); \
        const __m64 min = _mm_or_si64( _mm_andnot_si64( mask, A ), _mm_and_si64( mask, B ) ); \
        A = min; \
        B = max; \
    }
*/

//---------------------------------------------------------------------
// 8ߖTi3x3jŏXbh MMX
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer))  thread_8point_mmx( int thread_id, int thread_num, void *param1, void *param2 )
{
    const int *mask_table = (int *)param1;
    const FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Rs[
    const int w      = fpip->w;
    const int h      = fpip->h;
    const int max_w  = fpip->max_w;

    // sȒl͒e
    if( h <= 0 || w <= 0 || max_w <= 0 || thread_num <= 0 )
    {
        _mm_empty(); // MMXgĂ֐Ȃ̂ŔÔ
        return;
    }

    // Xbhc̃TCY葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num || thread_id < 0 )
    {
        _mm_empty(); // MMXgĂ֐Ȃ̂ŔÔ
        return;
    }

    // Xbh̉摜郉CvZ
    const int y_start = (h *  thread_id     ) / thread_num;
    const int y_end   = (h * (thread_id + 1)) / thread_num;

    // ㉺̃}XN͈
    int mask_top    = mask_table[MASK_TOP];
    int mask_bottom = mask_table[MASK_BOTTOM];
    if( mask_top    <= 0 ) mask_top    = 1; // ʂ̗[͏Ȃ
    if( mask_bottom <= 0 ) mask_bottom = 1; // 

    // Ȅ͈͂vZ
    int x_start = 0 + mask_table[MASK_LEFT];
    int x_end   = w - mask_table[MASK_RIGHT];
    if( x_start <= 0 ) x_start = 1; // ʂ̗[͏Ȃ
    if( x_end > w-1 ) x_end = w-1;  // 

    // |C^
    const PIXEL_YC *__restrict__ src = fpip->ycp_edit;
          PIXEL_YC *__restrict__ dst = fpip->ycp_temp;

    for( int y = y_start; y < y_end; y++ )
    {
        // }XN̈͂̂܂܃Rs[
        if( y < mask_top || y >= h - mask_bottom )
        {
            memcpy( dst + y*max_w, src + y*max_w, w*sizeof(src[0]) );
            continue;
        }

        int x = 0;

        // [̂܂܃Rs[
        for( ; x < x_start; x++ ) dst[y*max_w+x] = src[y*max_w+x];

        // MMX4
        for( ; x < x_end - 3; x += 4 )
        {
            // 3\[g
            __m64 m0 = MK_M64( src[(y-1)*max_w+x-1].y, src[(y-1)*max_w+x  ].y, src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y );
            __m64 m1 = MK_M64( src[(y-1)*max_w+x  ].y, src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y, src[(y-1)*max_w+x+3].y );
            __m64 m2 = MK_M64( src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y, src[(y-1)*max_w+x+3].y, src[(y-1)*max_w+x+4].y );
            MIN_MAX_MMX( m0, m1 );
            MIN_MAX_MMX( m1, m2 );
            MIN_MAX_MMX( m0, m1 );

            // FɃRs[
            dst[y*max_w+x+0].cb = src[y*max_w+x+0].cb;
            dst[y*max_w+x+0].cr = src[y*max_w+x+0].cr;
            dst[y*max_w+x+1].cb = src[y*max_w+x+1].cb;
            dst[y*max_w+x+1].cr = src[y*max_w+x+1].cr;
            dst[y*max_w+x+2].cb = src[y*max_w+x+2].cb;
            dst[y*max_w+x+2].cr = src[y*max_w+x+2].cr;
            dst[y*max_w+x+3].cb = src[y*max_w+x+3].cb;
            dst[y*max_w+x+3].cr = src[y*max_w+x+3].cr;

            // 3\[g
            __m64 m3 = MK_M64( src[y*max_w+x-1].y, src[y*max_w+x  ].y, src[y*max_w+x+1].y, src[y*max_w+x+2].y );
            __m64 m4 = MK_M64( src[y*max_w+x  ].y, src[y*max_w+x+1].y, src[y*max_w+x+2].y, src[y*max_w+x+3].y );
            __m64 m5 = MK_M64( src[y*max_w+x+1].y, src[y*max_w+x+2].y, src[y*max_w+x+3].y, src[y*max_w+x+4].y );
            MIN_MAX_MMX( m3, m4 );
            MIN_MAX_MMX( m4, m5 );
            MIN_MAX_MMX( m3, m4 );

            // ɂł鏈
            MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m2, m5 );
            MIN_MAX_MMX( m1, m4 );

            // 3\[g
            __m64 m6 = MK_M64( src[(y+1)*max_w+x-1].y, src[(y+1)*max_w+x  ].y, src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y );
            __m64 m7 = MK_M64( src[(y+1)*max_w+x  ].y, src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y, src[(y+1)*max_w+x+3].y );
            __m64 m8 = MK_M64( src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y, src[(y+1)*max_w+x+3].y, src[(y+1)*max_w+x+4].y );
            MIN_MAX_MMX( m6, m7 );
            MIN_MAX_MMX( m7, m8 );
            MIN_MAX_MMX( m6, m7 );

            // 3̂ԑ傫̂m6
            //MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m3, m6 );
            // 3̂ԏ̂m2
            //MIN_MAX_MMX( m2, m5 );
            MIN_MAX_MMX( m2, m8 );
            // 3̂^񒆂m4
            //MIN_MAX_MMX( m1, m4 );
            MIN_MAX_MMX( m4, m7 );
            MIN_MAX_MMX( m1, m4 );

            // m2, m4, m6̐^񒆂l
            MIN_MAX_MMX( m2, m4 );
            MIN_MAX_MMX( m4, m6 );
            MIN_MAX_MMX( m2, m4 );

            // lifBAjƒu
            // m4lifBAj
            dst[y*max_w+x+0].y  = _m_to_int( m4 );
            dst[y*max_w+x+1].y  = _m_to_int( m4 ) >> 16;
            dst[y*max_w+x+2].y  = _m_to_int( _mm_srli_si64( m4, 32 ) );
            dst[y*max_w+x+3].y  = _m_to_int( _mm_srli_si64( m4, 32 ) ) >> 16;
        }

        // [2
        if( x < x_end - 1 )
        {
            // 3\[g
            __m64 m0 = _m_from_int( MK_INT( src[(y-1)*max_w+x-1].y, src[(y-1)*max_w+x  ].y ) );
            __m64 m1 = _m_from_int( MK_INT( src[(y-1)*max_w+x  ].y, src[(y-1)*max_w+x+1].y ) );
            MIN_MAX_MMX( m0, m1 );
            __m64 m2 = _m_from_int( MK_INT( src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y ) );
            MIN_MAX_MMX( m1, m2 );
            MIN_MAX_MMX( m0, m1 );

            // FɃRs[
            dst[y*max_w+x+0].cb = src[y*max_w+x+0].cb;
            dst[y*max_w+x+0].cr = src[y*max_w+x+0].cr;
            dst[y*max_w+x+1].cb = src[y*max_w+x+1].cb;
            dst[y*max_w+x+1].cr = src[y*max_w+x+1].cr;

            // 3\[g
            __m64 m3 = _m_from_int( MK_INT( src[y*max_w+x-1].y, src[y*max_w+x  ].y ) );
            __m64 m4 = _m_from_int( MK_INT( src[y*max_w+x  ].y, src[y*max_w+x+1].y ) );
            MIN_MAX_MMX( m3, m4 );
            __m64 m5 = _m_from_int( MK_INT( src[y*max_w+x+1].y, src[y*max_w+x+2].y ) );
            MIN_MAX_MMX( m4, m5 );
            MIN_MAX_MMX( m3, m4 );

            // ɂł鏈
            MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m2, m5 );
            MIN_MAX_MMX( m1, m4 );

            // 3\[g
            __m64 m6 = _m_from_int( MK_INT( src[(y+1)*max_w+x-1].y, src[(y+1)*max_w+x  ].y ) );
            __m64 m7 = _m_from_int( MK_INT( src[(y+1)*max_w+x  ].y, src[(y+1)*max_w+x+1].y ) );
            MIN_MAX_MMX( m6, m7 );
            __m64 m8 = _m_from_int( MK_INT( src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y ) );
            MIN_MAX_MMX( m7, m8 );
            MIN_MAX_MMX( m6, m7 );

            // 3̂ԑ傫̂m6
            //MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m3, m6 );
            // 3̂ԏ̂m2
            //MIN_MAX_MMX( m2, m5 );
            MIN_MAX_MMX( m2, m8 );
            // 3̂^񒆂m4
            //MIN_MAX_MMX( m1, m4 );
            MIN_MAX_MMX( m4, m7 );
            MIN_MAX_MMX( m1, m4 );

            // m2, m4, m6̐^񒆂l
            MIN_MAX_MMX( m2, m4 );
            MIN_MAX_MMX( m4, m6 );
            MIN_MAX_MMX( m2, m4 );

            // lifBAjƒu
            dst[y*max_w+x+0].y  = _m_to_int( m4 );
            dst[y*max_w+x+1].y  = _m_to_int( m4 ) >> 16;

            x += 2;
        }
        // [1
        if( x < x_end )
        {
            // 3\[g
            __m64 m0 = _m_from_int( src[(y-1)*max_w+x-1].y );
            __m64 m1 = _m_from_int( src[(y-1)*max_w+x  ].y );
            MIN_MAX_MMX( m0, m1 );
            __m64 m2 = _m_from_int( src[(y-1)*max_w+x+1].y );
            MIN_MAX_MMX( m1, m2 );
            MIN_MAX_MMX( m0, m1 );

            // FɃRs[
            dst[y*max_w+x].cb = src[y*max_w+x].cb;
            dst[y*max_w+x].cr = src[y*max_w+x].cr;

            // 3\[g
            __m64 m3 = _m_from_int( src[y*max_w+x-1].y );
            __m64 m4 = _m_from_int( src[y*max_w+x  ].y );
            MIN_MAX_MMX( m3, m4 );
            __m64 m5 = _m_from_int( src[y*max_w+x+1].y );
            MIN_MAX_MMX( m4, m5 );
            MIN_MAX_MMX( m3, m4 );

            // ɂł鏈
            MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m2, m5 );
            MIN_MAX_MMX( m1, m4 );

            // 3\[g
            __m64 m6 = _m_from_int( src[(y+1)*max_w+x-1].y );
            __m64 m7 = _m_from_int( src[(y+1)*max_w+x  ].y );
            MIN_MAX_MMX( m6, m7 );
            __m64 m8 = _m_from_int( src[(y+1)*max_w+x+1].y );
            MIN_MAX_MMX( m7, m8 );
            MIN_MAX_MMX( m6, m7 );

            // 3̂ԑ傫̂m6
            //MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m3, m6 );
            // 3̂ԏ̂m2
            //MIN_MAX_MMX( m2, m5 );
            MIN_MAX_MMX( m2, m8 );
            // 3̂^񒆂m4
            //MIN_MAX_MMX( m1, m4 );
            MIN_MAX_MMX( m4, m7 );
            MIN_MAX_MMX( m1, m4 );

            // m2, m4, m6̐^񒆂l
            MIN_MAX_MMX( m2, m4 );
            MIN_MAX_MMX( m4, m6 );
            MIN_MAX_MMX( m2, m4 );

            // lifBAjƒu
            dst[y*max_w+x].y  = _m_to_int( m4 );

            x++;
        }

        // E[̂܂܃Rs[
        for( ; x < w; x++ ) dst[y*max_w+x] = src[y*max_w+x];
    }

    _mm_empty(); // MMXgĂ̂
}

//---------------------------------------------------------------------
// 8ߖTi3x3jŏXbh MMX F
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer))  thread_8point_chroma_mmx( int thread_id, int thread_num, void *param1, void *param2 )
{
    const int *mask_table = (int *)param1;
    const FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Rs[
    int w      = fpip->w;
    int h      = fpip->h;
    int max_w  = fpip->max_w;

    // sȒl͒e
    if( h <= 0 || w <= 0 || max_w <= 0 || thread_num <= 0 )
    {
        _mm_empty(); // MMXgĂ֐Ȃ̂ŔÔ
        return;
    }

    // Xbhc̃TCY葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num || thread_id < 0 )
    {
        _mm_empty(); // MMXgĂ֐Ȃ̂ŔÔ
        return;
    }

    // Xbh̉摜郉CvZ
    const int y_start = (h *  thread_id     ) / thread_num;
    const int y_end   = (h * (thread_id + 1)) / thread_num;

    // ㉺̃}XN͈
    int mask_top    = mask_table[MASK_TOP];
    int mask_bottom = mask_table[MASK_BOTTOM];
    if( mask_top    <= 0 ) mask_top    = 1; // ʂ̗[͏Ȃ
    if( mask_bottom <= 0 ) mask_bottom = 1; // 

    // Ȅ͈͂vZ
    int x_start = 0 + mask_table[MASK_LEFT];
    int x_end   = w - mask_table[MASK_RIGHT];
    if( x_start <= 0 ) x_start = 1; // ʂ̗[͏Ȃ
    if( x_end > w-1 ) x_end = w-1;  // 

    // short^Pʂł̂3{
    x_start *= 3;
    x_end   *= 3;
    w       *= 3;
    max_w   *= 3;

    // |C^ishort^j
    const short *__restrict__ src = (short *)fpip->ycp_edit;
          short *__restrict__ dst = (short *)fpip->ycp_temp;

    for( int y = y_start; y < y_end; y++ )
    {
        // }XN̈͂̂܂܃Rs[
        if( y < mask_top || y >= h - mask_bottom )
        {
            memcpy( dst + y*max_w, src + y*max_w, w*sizeof(src[0]) );
            continue;
        }

        int x = 0;

        // [̂܂܃Rs[
        for( ; x < x_start; x++ ) dst[y*max_w+x] = src[y*max_w+x];

        // MMX4
        for( ; x < x_end - 3; x += 4 )
        {
            // 3\[g
            __m64 m0 = *(__m64 *)&src[(y-1)*max_w+x-3];
            __m64 m1 = *(__m64 *)&src[(y-1)*max_w+x  ];
            MIN_MAX_MMX( m0, m1 );
            __m64 m2 = *(__m64 *)&src[(y-1)*max_w+x+3];
            MIN_MAX_MMX( m1, m2 );
            MIN_MAX_MMX( m0, m1 );

            // 3\[g
            __m64 m3 = *(__m64 *)&src[y*max_w+x-3];
            __m64 m4 = *(__m64 *)&src[y*max_w+x  ];
            MIN_MAX_MMX( m3, m4 );
            __m64 m5 = *(__m64 *)&src[y*max_w+x+3];
            MIN_MAX_MMX( m4, m5 );
            MIN_MAX_MMX( m3, m4 );

            // ɂł鏈
            MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m2, m5 );
            MIN_MAX_MMX( m1, m4 );

            // 3\[g
            __m64 m6 = *(__m64 *)&src[(y+1)*max_w+x-3];
            __m64 m7 = *(__m64 *)&src[(y+1)*max_w+x  ];
            MIN_MAX_MMX( m6, m7 );
            __m64 m8 = *(__m64 *)&src[(y+1)*max_w+x+3];
            MIN_MAX_MMX( m7, m8 );
            MIN_MAX_MMX( m6, m7 );

            // 3̂ԑ傫̂m6
            //MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m3, m6 );
            // 3̂ԏ̂m2
            //MIN_MAX_MMX( m2, m5 );
            MIN_MAX_MMX( m2, m8 );
            // 3̂^񒆂m4
            //MIN_MAX_MMX( m1, m4 );
            MIN_MAX_MMX( m4, m7 );
            MIN_MAX_MMX( m1, m4 );

            // m2, m4, m6̐^񒆂l
            MIN_MAX_MMX( m2, m4 );
            MIN_MAX_MMX( m4, m6 );
            MIN_MAX_MMX( m2, m4 );

            // lifBAjƒu
            // m4lifBAj
            *(__m64 *)&dst[y*max_w+x  ] = m4;
        }

        // [2
        if( x < x_end - 1 )
        {
            // 3\[g
            __m64 m0 = _m_from_int( MK_INT( src[(y-1)*max_w+x-3], src[(y-1)*max_w+x-2] ) );
            __m64 m1 = _m_from_int( MK_INT( src[(y-1)*max_w+x  ], src[(y-1)*max_w+x+1] ) );
            MIN_MAX_MMX( m0, m1 );
            __m64 m2 = _m_from_int( MK_INT( src[(y-1)*max_w+x+3], src[(y-1)*max_w+x+4] ) );
            MIN_MAX_MMX( m1, m2 );
            MIN_MAX_MMX( m0, m1 );

            // 3\[g
            __m64 m3 = _m_from_int( MK_INT( src[y*max_w+x-3], src[y*max_w+x-2] ) );
            __m64 m4 = _m_from_int( MK_INT( src[y*max_w+x  ], src[y*max_w+x+1] ) );
            MIN_MAX_MMX( m3, m4 );
            __m64 m5 = _m_from_int( MK_INT( src[y*max_w+x+3], src[y*max_w+x+4] ) );
            MIN_MAX_MMX( m4, m5 );
            MIN_MAX_MMX( m3, m4 );

            // ɂł鏈
            MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m2, m5 );
            MIN_MAX_MMX( m1, m4 );

            // 3\[g
            __m64 m6 = _m_from_int( MK_INT( src[(y+1)*max_w+x-3], src[(y+1)*max_w+x-2] ) );
            __m64 m7 = _m_from_int( MK_INT( src[(y+1)*max_w+x  ], src[(y+1)*max_w+x+1] ) );
            MIN_MAX_MMX( m6, m7 );
            __m64 m8 = _m_from_int( MK_INT( src[(y+1)*max_w+x+3], src[(y+1)*max_w+x+4] ) );
            MIN_MAX_MMX( m7, m8 );
            MIN_MAX_MMX( m6, m7 );

            // 3̂ԑ傫̂m6
            //MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m3, m6 );
            // 3̂ԏ̂m2
            //MIN_MAX_MMX( m2, m5 );
            MIN_MAX_MMX( m2, m8 );
            // 3̂^񒆂m4
            //MIN_MAX_MMX( m1, m4 );
            MIN_MAX_MMX( m4, m7 );
            MIN_MAX_MMX( m1, m4 );

            // m2, m4, m6̐^񒆂l
            MIN_MAX_MMX( m2, m4 );
            MIN_MAX_MMX( m4, m6 );
            MIN_MAX_MMX( m2, m4 );

            // lifBAjƒu
            dst[y*max_w+x+0] = _m_to_int( m4 );
            dst[y*max_w+x+1] = _m_to_int( m4 ) >> 16;

            x += 2;
        }
        // [1
        if( x < x_end )
        {
            // 3\[g
            __m64 m0 = _m_from_int( src[(y-1)*max_w+x-3] );
            __m64 m1 = _m_from_int( src[(y-1)*max_w+x  ] );
            MIN_MAX_MMX( m0, m1 );
            __m64 m2 = _m_from_int( src[(y-1)*max_w+x+3] );
            MIN_MAX_MMX( m1, m2 );
            MIN_MAX_MMX( m0, m1 );

            // 3\[g
            __m64 m3 = _m_from_int( src[y*max_w+x-3] );
            __m64 m4 = _m_from_int( src[y*max_w+x  ] );
            MIN_MAX_MMX( m3, m4 );
            __m64 m5 = _m_from_int( src[y*max_w+x+3] );
            MIN_MAX_MMX( m4, m5 );
            MIN_MAX_MMX( m3, m4 );

            // ɂł鏈
            MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m2, m5 );
            MIN_MAX_MMX( m1, m4 );

            // 3\[g
            __m64 m6 = _m_from_int( src[(y+1)*max_w+x-3] );
            __m64 m7 = _m_from_int( src[(y+1)*max_w+x  ] );
            MIN_MAX_MMX( m6, m7 );
            __m64 m8 = _m_from_int( src[(y+1)*max_w+x+3] );
            MIN_MAX_MMX( m7, m8 );
            MIN_MAX_MMX( m6, m7 );

            // 3̂ԑ傫̂m6
            //MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m3, m6 );
            // 3̂ԏ̂m2
            //MIN_MAX_MMX( m2, m5 );
            MIN_MAX_MMX( m2, m8 );
            // 3̂^񒆂m4
            //MIN_MAX_MMX( m1, m4 );
            MIN_MAX_MMX( m4, m7 );
            MIN_MAX_MMX( m1, m4 );

            // m2, m4, m6̐^񒆂l
            MIN_MAX_MMX( m2, m4 );
            MIN_MAX_MMX( m4, m6 );
            MIN_MAX_MMX( m2, m4 );

            // lifBAjƒu
            dst[y*max_w+x]  = _m_to_int( m4 );

            x++;
        }

        // E[̂܂܃Rs[
        for( ; x < w; x++ ) dst[y*max_w+x] = src[y*max_w+x];
    }

    _mm_empty(); // MMXgĂ̂
}

//---------------------------------------------------------------------
// 4ߖTŏXbh MMX
//---------------------------------------------------------------------
void thread_4point_mmx( int thread_id, int thread_num, void *param1, void *param2 )
{
    const int *mask_table = (int *)param1;
    const FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Rs[
    const int w      = fpip->w;
    const int h      = fpip->h;
    const int max_w  = fpip->max_w;

    // sȒl͒e
    if( h <= 0 || w <= 0 || max_w <= 0 || thread_num <= 0 )
    {
        _mm_empty(); // MMXgĂ֐Ȃ̂ŔÔ
        return;
    }

    // Xbhc葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num || thread_id < 0 )
    {
        _mm_empty(); // MMXgĂ֐Ȃ̂ŔÔ
        return;
    }

    // Xbh̃CvZ
    int y_start = (h *  thread_id     ) / thread_num;
    int y_end   = (h * (thread_id + 1)) / thread_num;

    // ㉺̃}XN͈
    int mask_top    = mask_table[MASK_TOP];
    int mask_bottom = mask_table[MASK_BOTTOM];
    if( mask_top    <= 0 ) mask_top    = 1; // ʂ̗[͏Ȃ
    if( mask_bottom <= 0 ) mask_bottom = 1; // 

    // Ȅ͈͂vZ
    int x_start = 0 + mask_table[MASK_LEFT];
    int x_end   = w - mask_table[MASK_RIGHT];
    if( x_start <= 0 ) x_start = 1; // ʂ̗[͏Ȃ
    if( x_end > w-1 ) x_end = w-1;  // 

    // |C^
    const PIXEL_YC *__restrict__ src = fpip->ycp_edit;
          PIXEL_YC *__restrict__ dst = fpip->ycp_temp;

    for( int y = y_start; y < y_end; y++ )
    {
        // }XN̈͂̂܂܃Rs[
        if( y < mask_top || y >= h - mask_bottom )
        {
            memcpy( dst + y*max_w, src + y*max_w, w*sizeof(src[0]) );
            continue;
        }

        int x = 0;

        // [̂܂܃Rs[
        for( ; x < x_start; x++ ) dst[y*max_w+x] = src[y*max_w+x];

        // MMX4
        for( ; x < x_end - 3; x += 4 )
        {
            __m64 m0 = MK_M64( src[y*max_w+x-1].y, src[y*max_w+x+0].y, src[y*max_w+x+1].y, src[y*max_w+x+2].y );
            __m64 m1 = MK_M64( src[y*max_w+x+0].y, src[y*max_w+x+1].y, src[y*max_w+x+2].y, src[y*max_w+x+3].y );
            __m64 m2 = MK_M64( src[y*max_w+x+1].y, src[y*max_w+x+2].y, src[y*max_w+x+3].y, src[y*max_w+x+4].y );
            __m64 m3 = MK_M64( src[(y-1)*max_w+x+0].y, src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y, src[(y-1)*max_w+x+3].y );
            __m64 m4 = MK_M64( src[(y+1)*max_w+x+0].y, src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y, src[(y+1)*max_w+x+3].y );
            MIN_MAX_MMX( m0, m1 );
            MIN_MAX_MMX( m3, m4 );
            MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m1, m4 );
            MIN_MAX_MMX( m2, m3 );
            MIN_MAX_MMX( m1, m2 );
            MIN_MAX_MMX( m2, m3 );
            // m2lifBAj
            dst[y*max_w+x+0].y  = _m_to_int( m2 );
            dst[y*max_w+x+0].cb = src[y*max_w+x+0].cb;
            dst[y*max_w+x+0].cr = src[y*max_w+x+0].cr;
            dst[y*max_w+x+1].y  = _m_to_int( m2 ) >> 16;
            dst[y*max_w+x+1].cb = src[y*max_w+x+1].cb;
            dst[y*max_w+x+1].cr = src[y*max_w+x+1].cr;
            m2 = _mm_srli_si64( m2, 32 );
            dst[y*max_w+x+2].y  = _m_to_int( m2 );
            dst[y*max_w+x+2].cb = src[y*max_w+x+2].cb;
            dst[y*max_w+x+2].cr = src[y*max_w+x+2].cr;
            dst[y*max_w+x+3].y  = _m_to_int( m2 ) >> 16;
            dst[y*max_w+x+3].cb = src[y*max_w+x+3].cb;
            dst[y*max_w+x+3].cr = src[y*max_w+x+3].cr;
        }
        // [2
        if( x < x_end - 1 )
        {
            __m64 m0 = _m_from_int( MK_INT( src[y*max_w+x-1].y, src[y*max_w+x+0].y ) );
            __m64 m1 = _m_from_int( MK_INT( src[y*max_w+x+0].y, src[y*max_w+x+1].y ) );
            __m64 m2 = _m_from_int( MK_INT( src[y*max_w+x+1].y, src[y*max_w+x+2].y ) );
            __m64 m3 = _m_from_int( MK_INT( src[(y-1)*max_w+x+0].y, src[(y-1)*max_w+x+1].y ) );
            __m64 m4 = _m_from_int( MK_INT( src[(y+1)*max_w+x+0].y, src[(y+1)*max_w+x+1].y ) );
            MIN_MAX_MMX( m0, m1 );
            MIN_MAX_MMX( m3, m4 );
            MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m1, m4 );
            MIN_MAX_MMX( m2, m3 );
            MIN_MAX_MMX( m1, m2 );
            MIN_MAX_MMX( m2, m3 ); 
            // m2lifBAj
            dst[y*max_w+x+0].y  = _m_to_int( m2 );
            dst[y*max_w+x+0].cb = src[y*max_w+x+0].cb;
            dst[y*max_w+x+0].cr = src[y*max_w+x+0].cr;
            dst[y*max_w+x+1].y  = _m_to_int( m2 ) >> 16;
            dst[y*max_w+x+1].cb = src[y*max_w+x+1].cb;
            dst[y*max_w+x+1].cr = src[y*max_w+x+1].cr;
            x += 2;
        }
        // [1
        if( x < x_end )
        {
            __m64 m0 = _m_from_int( src[y*max_w+x-1].y );
            __m64 m1 = _m_from_int( src[y*max_w+x  ].y );
            __m64 m2 = _m_from_int( src[y*max_w+x+1].y );
            __m64 m3 = _m_from_int( src[(y-1)*max_w+x].y );
            __m64 m4 = _m_from_int( src[(y+1)*max_w+x].y );
            MIN_MAX_MMX( m0, m1 );
            MIN_MAX_MMX( m3, m4 );
            MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m1, m4 );
            MIN_MAX_MMX( m2, m3 );
            MIN_MAX_MMX( m1, m2 );
            MIN_MAX_MMX( m2, m3 ); 
            // m2lifBAj
            dst[y*max_w+x].y  = _m_to_int( m2 );
            dst[y*max_w+x].cb = src[y*max_w+x].cb;
            dst[y*max_w+x].cr = src[y*max_w+x].cr;
            x++;
        }

        // E[̂܂܃Rs[
        for(; x < w; x++ ) dst[y*max_w+x] = src[y*max_w+x];
    }

    _mm_empty(); // MMXgĂ̂
}

//---------------------------------------------------------------------
// 4ߖTŏXbh MMX F
//---------------------------------------------------------------------
void thread_4point_chroma_mmx( int thread_id, int thread_num, void *param1, void *param2 )
{
    const int *mask_table = (int *)param1;
    const FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Rs[
    int w      = fpip->w;
    int h      = fpip->h;
    int max_w  = fpip->max_w;

    // sȒl͒e
    if( h <= 0 || w <= 0 || max_w <= 0 || thread_num <= 0 )
    {
        _mm_empty(); // MMXgĂ֐Ȃ̂ŔÔ
        return;
    }

    // Xbhc葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num || thread_id < 0 )
    {
        _mm_empty(); // MMXgĂ֐Ȃ̂ŔÔ
        return;
    }

    // Xbh̃CvZ
    int y_start = (h *  thread_id     ) / thread_num;
    int y_end   = (h * (thread_id + 1)) / thread_num;

    // ㉺̃}XN͈
    int mask_top    = mask_table[MASK_TOP];
    int mask_bottom = mask_table[MASK_BOTTOM];
    if( mask_top    <= 0 ) mask_top = 1;    // ʂ̗[͏Ȃ
    if( mask_bottom <= 0 ) mask_bottom = 1; // 

    // Ȅ͈͂vZ
    int x_start = 0 + mask_table[MASK_LEFT];
    int x_end   = w - mask_table[MASK_RIGHT];
    if( x_start <= 0 ) x_start = 1; // ʂ̗[͏Ȃ
    if( x_end > w-1  ) x_end = w-1; // 

    // short^Pʂł̂3{
    x_start *= 3;
    x_end   *= 3;
    w       *= 3;
    max_w   *= 3;

    // |C^ishort^Ɂj
    const short *__restrict__ src = (short *)fpip->ycp_edit;
          short *__restrict__ dst = (short *)fpip->ycp_temp;

    for( int y = y_start; y < y_end; y++ )
    {
        // }XN̈͂̂܂܃Rs[
        if( y < mask_top || y >= h - mask_bottom )
        {
            memcpy( dst + y*max_w, src + y*max_w, w*sizeof(src[0]) );
            continue;
        }

        int x = 0;

        // [̂܂܃Rs[
        for( ; x < x_start; x++ ) dst[y*max_w+x] = src[y*max_w+x];

        // MMX4
        for( ; x < x_end - 3; x += 4 )
        {
            __m64 m0 = *(__m64 *)&src[y*max_w+x-3];
            __m64 m1 = *(__m64 *)&src[y*max_w+x  ];
            __m64 m2 = *(__m64 *)&src[y*max_w+x+3];
            __m64 m3 = *(__m64 *)&src[(y-1)*max_w+x  ];
            __m64 m4 = *(__m64 *)&src[(y+1)*max_w+x  ];
            MIN_MAX_MMX( m0, m1 );
            MIN_MAX_MMX( m3, m4 );
            MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m1, m4 );
            MIN_MAX_MMX( m2, m3 );
            MIN_MAX_MMX( m1, m2 );
            MIN_MAX_MMX( m2, m3 );
            // m2lifBAj
            *(__m64 *)&dst[y*max_w+x  ] = m2;
        }
        // [2
        if( x < x_end - 1 )
        {
            __m64 m0 = _m_from_int( MK_INT( src[y*max_w+x-3], src[y*max_w+x-2] ) );
            __m64 m1 = _m_from_int( MK_INT( src[y*max_w+x+0], src[y*max_w+x+1] ) );
            __m64 m2 = _m_from_int( MK_INT( src[y*max_w+x+3], src[y*max_w+x+4] ) );
            __m64 m3 = _m_from_int( MK_INT( src[(y-1)*max_w+x  ], src[(y-1)*max_w+x+1] ) );
            __m64 m4 = _m_from_int( MK_INT( src[(y+1)*max_w+x  ], src[(y+1)*max_w+x+1] ) );
            MIN_MAX_MMX( m0, m1 );
            MIN_MAX_MMX( m3, m4 );
            MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m1, m4 );
            MIN_MAX_MMX( m2, m3 );
            MIN_MAX_MMX( m1, m2 );
            MIN_MAX_MMX( m2, m3 ); 
            // m2lifBAj
            dst[y*max_w+x+0] = _m_to_int( m2 );
            dst[y*max_w+x+1] = _m_to_int( m2 ) >> 16;
            x += 2;
        }
        // [1
        if( x < x_end )
        {
            __m64 m0 = _m_from_int( src[y*max_w+x-3] );
            __m64 m1 = _m_from_int( src[y*max_w+x  ] );
            __m64 m2 = _m_from_int( src[y*max_w+x+3] );
            __m64 m3 = _m_from_int( src[(y-1)*max_w+x] );
            __m64 m4 = _m_from_int( src[(y+1)*max_w+x] );
            MIN_MAX_MMX( m0, m1 );
            MIN_MAX_MMX( m3, m4 );
            MIN_MAX_MMX( m0, m3 );
            MIN_MAX_MMX( m1, m4 );
            MIN_MAX_MMX( m2, m3 );
            MIN_MAX_MMX( m1, m2 );
            MIN_MAX_MMX( m2, m3 ); 
            // m2lifBAj
            dst[y*max_w+x]  = _m_to_int( m2 );
            x++;
        }

        // E[̂܂܃Rs[
        for(; x < w; x++ ) dst[y*max_w+x] = src[y*max_w+x];
    }

    _mm_empty(); // MMXgĂ̂
}

//---------------------------------------------------------------------
// ͈͊mFpi]\j
//---------------------------------------------------------------------
void thread_invert( int thread_id, int thread_num, void *param1, void *param2 )
{
    const int *mask_table = (int *)param1;
    const FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Rs[
    const int w      = fpip->w;
    const int h      = fpip->h;
    const int max_w  = fpip->max_w;

    // sȒl͒e
    if( h <= 0 || w <= 0 || max_w <= 0 || thread_num <= 0 )
    {
        _mm_empty(); // MMXgĂ֐Ȃ̂ŔÔ
        return;
    }

    // Xbhc̏TCY葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num || thread_id < 0 )
    {
        _mm_empty(); // MMXgĂ֐Ȃ̂ŔÔ
        return;
    }

    // Xbh̉摜郉CvZ
    const int y_start = (h * (thread_id    )) / thread_num;
    const int y_end   = (h * (thread_id + 1)) / thread_num;

    // ㉺̃}XN͈
    int mask_top    = mask_table[MASK_TOP];
    int mask_bottom = mask_table[MASK_BOTTOM];
    if( mask_top    <= 0  ) mask_top    = 1;    // ʂ̗[͏Ȃ
    if( mask_bottom <= 0 ) mask_bottom = 1;  // 

    int x_start = 0 + mask_table[MASK_LEFT];
    int x_end   = w - mask_table[MASK_RIGHT];
    if( x_start <= 0 ) x_start = 1; // ʂ̗[͏Ȃ
    if( x_end > w-1 ) x_end = w-1;  // 

    PIXEL_YC *src = fpip->ycp_edit;

    for( int y=y_start; y<y_end; y++ )
    {
        if( y < mask_top || y >= h-mask_bottom || x_start >= x_end )
        {
            for( int x = 0; x < w; x++ )
            {
                src[y*max_w+x].y  = 4096 - src[y*max_w+x].y;
                src[y*max_w+x].cb = -src[y*max_w+x].cb;
                src[y*max_w+x].cr = -src[y*max_w+x].cr;
            }
            continue;
        }

        for( int x = 0; x < x_start; x++ )
        {
            src[y*max_w+x].y  = 4096 - src[y*max_w+x].y;
            src[y*max_w+x].cb = -src[y*max_w+x].cb;
            src[y*max_w+x].cr = -src[y*max_w+x].cr;
        }
        for( int x = x_end; x < w; x++ )
        {
            src[y*max_w+x].y  = 4096 - src[y*max_w+x].y;
            src[y*max_w+x].cb = -src[y*max_w+x].cb;
            src[y*max_w+x].cr = -src[y*max_w+x].cr;
        }
    }
}

//---------------------------------------------------------------------
// }`XbhΉo[Wp_~[֐
//---------------------------------------------------------------------
BOOL exec_mtf_dummy( MULTI_THREAD_FUNC func, void *param1, void *param2 )
{
    func( 0, 1, param1, param2 );
    return TRUE;
}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp, FILTER_PROC_INFO *fpip )
{
    // AviUtl̃}`Xbh֐̑I
    // Ήo[Wł exec_mtf_dummy gp
    BOOL (*exec_mtf)(MULTI_THREAD_FUNC, void*, void*) = fp->exfunc->exec_multi_thread_func ? fp->exfunc->exec_multi_thread_func : exec_mtf_dummy;

    // O͈̓Rs[
    int mask_table[TRACK_N];
    mask_table[MASK_TOP   ] = fp->track[MASK_TOP   ];
    mask_table[MASK_BOTTOM] = fp->track[MASK_BOTTOM];
    mask_table[MASK_LEFT  ] = fp->track[MASK_LEFT  ];
    mask_table[MASK_RIGHT ] = fp->track[MASK_RIGHT ];

    if( mask_table[MASK_TOP   ] <= 0 ) mask_table[MASK_TOP   ] = 1;
    if( mask_table[MASK_BOTTOM] <= 0 ) mask_table[MASK_BOTTOM] = 1;
    if( mask_table[MASK_LEFT  ] <= 0 ) mask_table[MASK_LEFT  ] = 1;
    if( mask_table[MASK_RIGHT ] <= 0 ) mask_table[MASK_RIGHT ] = 1;

    // OTCY摜TCY傫ꍇ͏Ȃ
    int mask_height = mask_table[MASK_TOP   ] + mask_table[MASK_BOTTOM];
    int mask_width  = mask_table[MASK_LEFT  ] + mask_table[MASK_RIGHT ];
    if( mask_height < fpip->h && mask_width < fpip->w && (!fp->check[0] || !!fp->check[1]) )
    {
        // s֐I
        MULTI_THREAD_FUNC func =
            ( fp->check[2] && (g_simd_flag & FLAG_SSE2) )
                ? fp->check[4]
                    ? fp->check[3] ? thread_4point_chroma_sse2 : thread_8point_chroma_sse2
                    : fp->check[3] ? thread_4point_sse2 : thread_8point_sse2
                : fp->check[4]
                    ? fp->check[3] ? thread_4point_chroma_mmx : thread_8point_chroma_mmx
                    : fp->check[3] ? thread_4point_mmx : thread_8point_mmx ;

        for( int i = 0; i < fp->track[EXE_TIMES]; i++ )
        {
            // s
            exec_mtf( func, mask_table, fpip );

            // 摜̈̃|C^ւ
            PIXEL_YC *ycp_swap = fpip->ycp_edit;
            fpip->ycp_edit = fpip->ycp_temp;
            fpip->ycp_temp = ycp_swap;
        }
    }

    // ͈͊mF[h
    if( !!fp->check[0] ) exec_mtf( thread_invert, mask_table, fpip );

    return TRUE;
}
