// SSE2gpp[g

#include <windows.h>
#include <mmintrin.h>
#include <xmmintrin.h>
#include <emmintrin.h>
#include "filter.h"

#include "median_filter.h"

// vtFb`piƐvtFb`ȂƌʂȂj
#define USE_PREFETCH
#define PREFETCH_HINT _MM_HINT_T1

// Xg[~Oo
#define USE_MOVNT

//---------------------------------------------------------------------
// short^8128bit֕ϊ镔łxς̂
// 낢뎎悤Ƀ}N
//---------------------------------------------------------------------

// short^232bitɂ
#define MK_INT( A, B ) ( (int)(unsigned short)A | ((int)B << 16) )

// short^8128bitɂ
//#define MK_M128I( A, B, C, D, E, F, G, H ) _mm_setr_epi32( MK_INT( A, B ), MK_INT( C, D ), MK_INT( E, F ), MK_INT( G, H ) )
//#define MK_M128I( A, B, C, D, E, F, G, H ) _mm_setr_epi16( A, B, C, D, E, F, G, H )

// short^8__m128iɑ}Ă
#define MK_M128I_S8( XMM, A, B, C, D, E, F, G, H ) \
    { \
        XMM = _mm_cvtsi32_si128( A ); \
        XMM = _mm_insert_epi16( XMM, B, 1 ); \
        XMM = _mm_insert_epi16( XMM, C, 2 ); \
        XMM = _mm_insert_epi16( XMM, D, 3 ); \
        XMM = _mm_insert_epi16( XMM, E, 4 ); \
        XMM = _mm_insert_epi16( XMM, F, 5 ); \
        XMM = _mm_insert_epi16( XMM, G, 6 ); \
        XMM = _mm_insert_epi16( XMM, H, 7 ); \
    }

// short^4__m128iɑ}Ă
#define MK_M128I_S4( XMM, A, B, C, D ) \
    { \
        XMM = _mm_cvtsi32_si128( A ); \
        XMM = _mm_insert_epi16( XMM, B, 1 ); \
        XMM = _mm_insert_epi16( XMM, C, 2 ); \
        XMM = _mm_insert_epi16( XMM, D, 3 ); \
    }

//---------------------------------------------------------------------
// rēւ
//---------------------------------------------------------------------
#define MIN_MAX_SSE2( A, B ) \
    { \
        const __m128i max = _mm_max_epi16( A, B ); \
        const __m128i min = _mm_min_epi16( B, A ); \
        A = min; \
        B = max; \
    }

//---------------------------------------------------------------------
// l
//---------------------------------------------------------------------
// 5vf
#define FIND_MEDIUM_FIVE( M0, M1, M2, M3, M4 ) \
    { \
        MIN_MAX_SSE2( M0, M1 ); \
        MIN_MAX_SSE2( M3, M4 ); \
        MIN_MAX_SSE2( M0, M3 ); \
        MIN_MAX_SSE2( M1, M4 ); \
        MIN_MAX_SSE2( M2, M3 ); \
        MIN_MAX_SSE2( M1, M2 ); \
        MIN_MAX_SSE2( M2, M3 ); \
    }
/*
// 9vfB
// x86łxmmWX^Ȃ̂łł͗]vȃXgA[hĂ܂B
// KɃ[h邱ƂŃXgA[h炷KvB
#define FIND_MEDIUM_NINE( M0, M1, M2, M3, M4, M5, M6, M7, M8 ) \
    { \
        MIN_MAX_SSE2( M0, M1 ); \
        MIN_MAX_SSE2( M1, M2 ); \
        MIN_MAX_SSE2( M0, M1 ); \
        MIN_MAX_SSE2( M3, M4 ); \
        MIN_MAX_SSE2( M4, M5 ); \
        MIN_MAX_SSE2( M3, M4 ); \
        MIN_MAX_SSE2( M0, M3 ); \
        MIN_MAX_SSE2( M2, M5 ); \
        MIN_MAX_SSE2( M1, M4 ); \
        MIN_MAX_SSE2( M6, M7 ); \
        MIN_MAX_SSE2( M7, M8 ); \
        MIN_MAX_SSE2( M6, M7 ); \
        MIN_MAX_SSE2( M3, M6 ); \
        MIN_MAX_SSE2( M2, M8 ); \
        MIN_MAX_SSE2( M4, M7 ); \
        MIN_MAX_SSE2( M1, M4 ); \
        MIN_MAX_SSE2( M2, M4 ); \
        MIN_MAX_SSE2( M4, M6 ); \
        MIN_MAX_SSE2( M2, M4 ); \
    }
*/

//---------------------------------------------------------------------
// my_memcpy
//---------------------------------------------------------------------
void __declspec(noinline) my_memcpy( void *__restrict__  b, const void *__restrict__  a, size_t n )
{
    // xNgɗꍇ
    char *__restrict__ s1 = (char *)b;
    const char *__restrict__ s2 = (char *)a;
    for( ; 0<n; --n ) *s1++ = *s2++;
}

//---------------------------------------------------------------------
// 8ߖTi3x3jŏXbh SSE2
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_8point_sse2( int thread_id, int thread_num, void *param1, void *param2 )
{
    const int *mask_table = (int *)param1;
    const FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Rs[
    const int w      = fpip->w;
    const int h      = fpip->h;
    const int max_w  = fpip->max_w;

    // sȒl͒e
    if( h <= 0 || w <= 0 || max_w <= 0 || thread_num <= 0 ) return;

    // Xbhc̃TCY葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num || thread_id < 0 ) return;

    // Xbh̉摜郉CvZ
    const int y_start = (h *  thread_id     ) / thread_num;
    const int y_end   = (h * (thread_id + 1)) / thread_num;

    // ㉺̃}XN͈
    int mask_top    = mask_table[MASK_TOP];
    int mask_bottom = mask_table[MASK_BOTTOM];
    if( mask_top    <= 0  ) mask_top    = 1; // ʂ̗[͏Ȃ
    if( mask_bottom <= 0 ) mask_bottom = 1;  // 

    // Ȅ͈͂vZ
    int x_start = 0 + mask_table[MASK_LEFT];
    int x_end   = w - mask_table[MASK_RIGHT];
    if( x_start <= 0 ) x_start = 1; // ʂ̗[͏Ȃ
    if( x_end > w-1 ) x_end = w-1;  // 

    // |C^
    const PIXEL_YC *__restrict__ src = fpip->ycp_edit;
          PIXEL_YC *__restrict__ dst = fpip->ycp_temp;

    for( int y = y_start; y < y_end; y++ )
    {
        // }XN̈͂̂܂܃Rs[
        if( y < mask_top || y >= h - mask_bottom )
        {
            my_memcpy( dst + y*max_w, src + y*max_w, w*sizeof(src[0]) );
            continue;
        }

        int x = 0;

        // [̂܂܃Rs[
        for( ; x<x_start; x++ ) dst[y*max_w+x] = src[y*max_w+x];

#ifdef USE_MOVNT
        // o͑|C^16byteACgɍ킹AXg[~Oo
        // paddingshort^(2byte)P  xKvB
        int padding = (unsigned int)&dst[y*max_w+x] & 0xF;
        if( (x_end-x_start) > 15 && !(padding & 0x1) )
        {
            padding = ((padding>>1) * 5) & 0x7; // ̂ɕKvYC48̐

#ifdef USE_PREFETCH
            _mm_prefetch( &src[(y+2)*max_w+x].y, PREFETCH_HINT ); // ̃CvtFb`
#endif

            if( padding & 0x1 ) // YC48 1
            {
                __m128i m0 = _mm_cvtsi32_si128( src[(y-1)*max_w+x-1].y );
                __m128i m1 = _mm_cvtsi32_si128( src[(y-1)*max_w+x  ].y );
                __m128i m2 = _mm_cvtsi32_si128( src[(y-1)*max_w+x+1].y );
                MIN_MAX_SSE2( m0, m1 );
                MIN_MAX_SSE2( m1, m2 );
                MIN_MAX_SSE2( m0, m1 );
                __m128i m3 = _mm_cvtsi32_si128( src[y*max_w+x-1].y );
                __m128i m4 = _mm_cvtsi32_si128( src[y*max_w+x  ].y );
                __m128i m5 = _mm_cvtsi32_si128( src[y*max_w+x+1].y );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m4, m5 );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m0, m3 );
                MIN_MAX_SSE2( m2, m5 );
                MIN_MAX_SSE2( m1, m4 );
                __m128i m6 = _mm_cvtsi32_si128( src[(y+1)*max_w+x-1].y );
                __m128i m7 = _mm_cvtsi32_si128( src[(y+1)*max_w+x  ].y );
                __m128i m8 = _mm_cvtsi32_si128( src[(y+1)*max_w+x+1].y );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m7, m8 );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m3, m6 );
                MIN_MAX_SSE2( m2, m8 );
                MIN_MAX_SSE2( m4, m7 );
                MIN_MAX_SSE2( m1, m4 );
                MIN_MAX_SSE2( m2, m4 );
                MIN_MAX_SSE2( m4, m6 );
                MIN_MAX_SSE2( m2, m4 );
                dst[y*max_w+x+0].y  = _mm_extract_epi16( m4, 0 );
                dst[y*max_w+x+0].cb = src[y*max_w+x+0].cb;
                dst[y*max_w+x+0].cr = src[y*max_w+x+0].cr;
                x++;
            }
            if( padding & 0x2 ) // YC48 2
            {
                __m128i m0 = _mm_cvtsi32_si128( MK_INT( src[(y-1)*max_w+x-1].y, src[(y-1)*max_w+x  ].y ) );
                __m128i m1 = _mm_cvtsi32_si128( MK_INT( src[(y-1)*max_w+x  ].y, src[(y-1)*max_w+x+1].y ) );
                __m128i m2 = _mm_cvtsi32_si128( MK_INT( src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y ) );
                MIN_MAX_SSE2( m0, m1 );
                MIN_MAX_SSE2( m1, m2 );
                MIN_MAX_SSE2( m0, m1 );
                __m128i m3 = _mm_cvtsi32_si128( MK_INT( src[y*max_w+x-1].y, src[y*max_w+x  ].y ) );
                __m128i m4 = _mm_cvtsi32_si128( MK_INT( src[y*max_w+x  ].y, src[y*max_w+x+1].y ) );
                __m128i m5 = _mm_cvtsi32_si128( MK_INT( src[y*max_w+x+1].y, src[y*max_w+x+2].y ) );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m4, m5 );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m0, m3 );
                MIN_MAX_SSE2( m2, m5 );
                MIN_MAX_SSE2( m1, m4 );
                __m128i m6 = _mm_cvtsi32_si128( MK_INT( src[(y+1)*max_w+x-1].y, src[(y+1)*max_w+x  ].y ) );
                __m128i m7 = _mm_cvtsi32_si128( MK_INT( src[(y+1)*max_w+x  ].y, src[(y+1)*max_w+x+1].y ) );
                __m128i m8 = _mm_cvtsi32_si128( MK_INT( src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y ) );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m7, m8 );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m3, m6 );
                MIN_MAX_SSE2( m2, m8 );
                MIN_MAX_SSE2( m4, m7 );
                MIN_MAX_SSE2( m1, m4 );
                MIN_MAX_SSE2( m2, m4 );
                MIN_MAX_SSE2( m4, m6 );
                MIN_MAX_SSE2( m2, m4 );
                // 32bit(4byte)Xg[~Oo
                _mm_stream_si32( (int *)&dst[y*max_w+x+0].y , MK_INT( _mm_extract_epi16( m4, 0 ), src[y*max_w+x+0].cb ) );
                _mm_stream_si32( (int *)&dst[y*max_w+x+0].cr, MK_INT( src[y*max_w+x+0].cr, _mm_extract_epi16( m4, 1 ) ) );
                _mm_stream_si32( (int *)&dst[y*max_w+x+1].cb, MK_INT( src[y*max_w+x+1].cb, src[y*max_w+x+1].cr ) );
                x += 2;
            }
            if( padding & 0x4 ) // YC48 4
            {
                __m128i m0, m1, m2;
                __m128i m3, m4, m5;
                __m128i m6, m7, m8;
                MK_M128I_S4( m0, src[(y-1)*max_w+x-1].y, src[(y-1)*max_w+x  ].y, src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y );
                m1 = _mm_insert_epi16( _mm_srli_si128( m0, 16/8 ), src[(y-1)*max_w+x+3].y, 3 );
                m2 = _mm_insert_epi16( _mm_srli_si128( m1, 16/8 ), src[(y-1)*max_w+x+4].y, 3 );
                MIN_MAX_SSE2( m0, m1 );
                MIN_MAX_SSE2( m1, m2 );
                MIN_MAX_SSE2( m0, m1 );
                MK_M128I_S4( m3, src[y*max_w+x-1].y, src[y*max_w+x  ].y, src[y*max_w+x+1].y, src[y*max_w+x+2].y );
                m4 = _mm_insert_epi16( _mm_srli_si128( m3, 16/8 ), src[y*max_w+x+3].y, 3 );
                m5 = _mm_insert_epi16( _mm_srli_si128( m4, 16/8 ), src[y*max_w+x+4].y, 3 );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m4, m5 );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m0, m3 );
                MIN_MAX_SSE2( m2, m5 );
                MIN_MAX_SSE2( m1, m4 );
                MK_M128I_S4( m6, src[(y+1)*max_w+x-1].y, src[(y+1)*max_w+x  ].y, src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y );
                m7 = _mm_insert_epi16( _mm_srli_si128( m6, 16/8 ), src[(y+1)*max_w+x+3].y, 3 );
                m8 = _mm_insert_epi16( _mm_srli_si128( m7, 16/8 ), src[(y+1)*max_w+x+4].y, 3 );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m7, m8 );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m3, m6 );
                MIN_MAX_SSE2( m2, m8 );
                MIN_MAX_SSE2( m4, m7 );
                MIN_MAX_SSE2( m1, m4 );
                MIN_MAX_SSE2( m2, m4 );
                MIN_MAX_SSE2( m4, m6 );
                MIN_MAX_SSE2( m2, m4 );
                // 32bit(4byte)Xg[~Oo
                _mm_stream_si32( (int *)&dst[y*max_w+x+0].y , MK_INT( _mm_extract_epi16( m4, 0 ), src[y*max_w+x+0].cb ) );
                _mm_stream_si32( (int *)&dst[y*max_w+x+0].cr, MK_INT( src[y*max_w+x+0].cr, _mm_extract_epi16( m4, 1 ) ) );
                // 16byteACɑĂ̂ŁA16byteŃXg[~Oo
                __m128i out0 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+1].cb );
                out0 = _mm_insert_epi16( out0, _mm_extract_epi16( m4, 2 ), 2 );
                out0 = _mm_insert_epi16( out0, _mm_extract_epi16( m4, 3 ), 5 );
                _mm_stream_si128( (__m128i *)&dst[y*max_w+x+1].cb, out0 );
                x += 4;
            }

            // o͑̃ACg
            // SSE28
            for( ; x < x_end - 7; x += 8 )
            {
                __m128i m0, m1, m2;
                __m128i m3, m4, m5;
                __m128i m6, m7, m8;

                // 3\[g
                MK_M128I_S8( m1, src[(y-1)*max_w+x  ].y, src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y, src[(y-1)*max_w+x+3].y, src[(y-1)*max_w+x+4].y, src[(y-1)*max_w+x+5].y, src[(y-1)*max_w+x+6].y, src[(y-1)*max_w+x+7].y );
                m0 = _mm_insert_epi16( _mm_slli_si128( m1, 16/8 ), src[(y-1)*max_w+x-1].y, 0 );
                m2 = _mm_insert_epi16( _mm_srli_si128( m1, 16/8 ), src[(y-1)*max_w+x+8].y, 7 );
                MIN_MAX_SSE2( m0, m1 );
                MIN_MAX_SSE2( m1, m2 );
                MIN_MAX_SSE2( m0, m1 );

                // 3\[g
                MK_M128I_S8( m4, src[y*max_w+x  ].y, src[y*max_w+x+1].y, src[y*max_w+x+2].y, src[y*max_w+x+3].y, src[y*max_w+x+4].y, src[y*max_w+x+5].y, src[y*max_w+x+6].y, src[y*max_w+x+7].y );
                m3 = _mm_insert_epi16( _mm_slli_si128( m4, 16/8 ), src[y*max_w+x-1].y, 0 );
                m5 = _mm_insert_epi16( _mm_srli_si128( m4, 16/8 ), src[y*max_w+x+8].y, 7 );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m4, m5 );
                MIN_MAX_SSE2( m3, m4 );

                // ɂł鏈
                MIN_MAX_SSE2( m0, m3 );
                MIN_MAX_SSE2( m2, m5 );
                MIN_MAX_SSE2( m1, m4 );

#ifdef USE_PREFETCH
                _mm_prefetch( &src[(y+2)*max_w+x].y, PREFETCH_HINT ); // ̃CvtFb`
#endif

                // 3\[g
                MK_M128I_S8( m7, src[(y+1)*max_w+x  ].y, src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y, src[(y+1)*max_w+x+3].y, src[(y+1)*max_w+x+4].y, src[(y+1)*max_w+x+5].y, src[(y+1)*max_w+x+6].y, src[(y+1)*max_w+x+7].y );
                m6 = _mm_insert_epi16( _mm_slli_si128( m7, 16/8 ), src[(y+1)*max_w+x-1].y, 0 );
                m8 = _mm_insert_epi16( _mm_srli_si128( m7, 16/8 ), src[(y+1)*max_w+x+8].y, 7 );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m7, m8 );
                MIN_MAX_SSE2( m6, m7 );

                // 3̂ԑ傫̂m6ցiꕔցj
                //MIN_MAX_SSE2( m0, m3 );
                MIN_MAX_SSE2( m3, m6 );
                // 3̂ԏ̂m2ցiꕔցj
                //MIN_MAX_SSE2( m2, m5 );
                MIN_MAX_SSE2( m2, m8 );
                // 3̂^񒆂m4ցiꕔցj
                //MIN_MAX_SSE2( m1, m4 );
                MIN_MAX_SSE2( m4, m7 );
                MIN_MAX_SSE2( m1, m4 );
                // m2, m4, m6̐^񒆂l
                MIN_MAX_SSE2( m2, m4 );
                MIN_MAX_SSE2( m4, m6 );
                MIN_MAX_SSE2( m2, m4 );

                // m4lifBAj
                __m128i out0 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+0].y  );
                __m128i out1 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+2].cr );
                __m128i out2 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+5].cb );
                out0 = _mm_insert_epi16( out0, _mm_extract_epi16( m4, 0 ), 0 );
                out0 = _mm_insert_epi16( out0, _mm_extract_epi16( m4, 1 ), 3 );
                out0 = _mm_insert_epi16( out0, _mm_extract_epi16( m4, 2 ), 6 );
                out1 = _mm_insert_epi16( out1, _mm_extract_epi16( m4, 3 ), 1 );
                out1 = _mm_insert_epi16( out1, _mm_extract_epi16( m4, 4 ), 4 );
                out1 = _mm_insert_epi16( out1, _mm_extract_epi16( m4, 5 ), 7 );
                out2 = _mm_insert_epi16( out2, _mm_extract_epi16( m4, 6 ), 2 );
                out2 = _mm_insert_epi16( out2, _mm_extract_epi16( m4, 7 ), 5 );
                // Xg[~Oo
                _mm_stream_si128( (__m128i *)&dst[y*max_w+x+0].y , out0 );
                _mm_stream_si128( (__m128i *)&dst[y*max_w+x+2].cr, out1 );
                _mm_stream_si128( (__m128i *)&dst[y*max_w+x+5].cb, out2 );
            }
        }
        else
#endif
        {
            // ACg낦Ȃ
            // SSE28
            for( ; x < x_end - 7; x += 8 )
            {
                __m128i m0, m1, m2;
                __m128i m3, m4, m5;
                __m128i m6, m7, m8;

                // 3\[g
                MK_M128I_S8( m1, src[(y-1)*max_w+x  ].y, src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y, src[(y-1)*max_w+x+3].y, src[(y-1)*max_w+x+4].y, src[(y-1)*max_w+x+5].y, src[(y-1)*max_w+x+6].y, src[(y-1)*max_w+x+7].y );
                m0 = _mm_insert_epi16( _mm_slli_si128( m1, 16/8 ), src[(y-1)*max_w+x-1].y, 0 );
                m2 = _mm_insert_epi16( _mm_srli_si128( m1, 16/8 ), src[(y-1)*max_w+x+8].y, 7 );
                MIN_MAX_SSE2( m0, m1 );
                MIN_MAX_SSE2( m1, m2 );
                MIN_MAX_SSE2( m0, m1 );

                // FɃRs[iPx܂Ƃ߂āj
                _mm_storeu_si128( (__m128i *)&dst[y*max_w+x+0].y , _mm_loadu_si128( (__m128i *)&src[y*max_w+x+0].y  ) );
                _mm_storeu_si128( (__m128i *)&dst[y*max_w+x+2].cr, _mm_loadu_si128( (__m128i *)&src[y*max_w+x+2].cr ) );
                _mm_storeu_si128( (__m128i *)&dst[y*max_w+x+5].cb, _mm_loadu_si128( (__m128i *)&src[y*max_w+x+5].cb ) );

                // 3\[g
                MK_M128I_S8( m4, src[y*max_w+x  ].y, src[y*max_w+x+1].y, src[y*max_w+x+2].y, src[y*max_w+x+3].y, src[y*max_w+x+4].y, src[y*max_w+x+5].y, src[y*max_w+x+6].y, src[y*max_w+x+7].y );
                m3 = _mm_insert_epi16( _mm_slli_si128( m4, 16/8 ), src[y*max_w+x-1].y, 0 );
                m5 = _mm_insert_epi16( _mm_srli_si128( m4, 16/8 ), src[y*max_w+x+8].y, 7 );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m4, m5 );
                MIN_MAX_SSE2( m3, m4 );

                // ɂł鏈
                MIN_MAX_SSE2( m0, m3 );
                MIN_MAX_SSE2( m2, m5 );
                MIN_MAX_SSE2( m1, m4 );

#ifdef USE_PREFETCH
                _mm_prefetch( &src[(y+2)*max_w+x].y, PREFETCH_HINT ); // ̃CvtFb`
#endif
                // 3\[g
                MK_M128I_S8( m7, src[(y+1)*max_w+x  ].y, src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y, src[(y+1)*max_w+x+3].y, src[(y+1)*max_w+x+4].y, src[(y+1)*max_w+x+5].y, src[(y+1)*max_w+x+6].y, src[(y+1)*max_w+x+7].y );
                m6 = _mm_insert_epi16( _mm_slli_si128( m7, 16/8 ), src[(y+1)*max_w+x-1].y, 0 );
                m8 = _mm_insert_epi16( _mm_srli_si128( m7, 16/8 ), src[(y+1)*max_w+x+8].y, 7 );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m7, m8 );
                MIN_MAX_SSE2( m6, m7 );

                // 3̂ԑ傫̂m6ցiꕔցj
                //MIN_MAX_SSE2( m0, m3 );
                MIN_MAX_SSE2( m3, m6 );
                // 3̂ԏ̂m2ցiꕔցj
                //MIN_MAX_SSE2( m2, m5 );
                MIN_MAX_SSE2( m2, m8 );
                // 3̂^񒆂m4ցiꕔցj
                //MIN_MAX_SSE2( m1, m4 );
                MIN_MAX_SSE2( m4, m7 );
                MIN_MAX_SSE2( m1, m4 );
                // m2, m4, m6̐^񒆂l
                MIN_MAX_SSE2( m2, m4 );
                MIN_MAX_SSE2( m4, m6 );
                MIN_MAX_SSE2( m2, m4 );

                // m4lifBAj
                dst[y*max_w+x+0].y = _mm_extract_epi16( m4, 0 );
                dst[y*max_w+x+1].y = _mm_extract_epi16( m4, 1 );
                dst[y*max_w+x+2].y = _mm_extract_epi16( m4, 2 );
                dst[y*max_w+x+3].y = _mm_extract_epi16( m4, 3 );
                dst[y*max_w+x+4].y = _mm_extract_epi16( m4, 4 );
                dst[y*max_w+x+5].y = _mm_extract_epi16( m4, 5 );
                dst[y*max_w+x+6].y = _mm_extract_epi16( m4, 6 );
                dst[y*max_w+x+7].y = _mm_extract_epi16( m4, 7 );
            }
        }

        // [4
        if( x < x_end - 3 )
        {
            __m128i m0, m1, m2;
            __m128i m3, m4, m5;
            __m128i m6, m7, m8;
            MK_M128I_S4( m0, src[(y-1)*max_w+x-1].y, src[(y-1)*max_w+x  ].y, src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y );
            m1 = _mm_insert_epi16( _mm_srli_si128( m0, 16/8 ), src[(y-1)*max_w+x+3].y, 3 );
            m2 = _mm_insert_epi16( _mm_srli_si128( m1, 16/8 ), src[(y-1)*max_w+x+4].y, 3 );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            dst[y*max_w+x+0].cb = src[y*max_w+x+0].cb;
            dst[y*max_w+x+0].cr = src[y*max_w+x+0].cr;
            dst[y*max_w+x+1].cb = src[y*max_w+x+1].cb;
            dst[y*max_w+x+1].cr = src[y*max_w+x+1].cr;
            dst[y*max_w+x+2].cb = src[y*max_w+x+2].cb;
            dst[y*max_w+x+2].cr = src[y*max_w+x+2].cr;
            dst[y*max_w+x+3].cb = src[y*max_w+x+3].cb;
            dst[y*max_w+x+3].cr = src[y*max_w+x+3].cr;
            MK_M128I_S4( m3, src[y*max_w+x-1].y, src[y*max_w+x  ].y, src[y*max_w+x+1].y, src[y*max_w+x+2].y );
            m4 = _mm_insert_epi16( _mm_srli_si128( m3, 16/8 ), src[y*max_w+x+3].y, 3 );
            m5 = _mm_insert_epi16( _mm_srli_si128( m4, 16/8 ), src[y*max_w+x+4].y, 3 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            MK_M128I_S4( m6, src[(y+1)*max_w+x-1].y, src[(y+1)*max_w+x  ].y, src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y );
            m7 = _mm_insert_epi16( _mm_srli_si128( m6, 16/8 ), src[(y+1)*max_w+x+3].y, 3 );
            m8 = _mm_insert_epi16( _mm_srli_si128( m7, 16/8 ), src[(y+1)*max_w+x+4].y, 3 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );
            dst[y*max_w+x+0].y  = _mm_extract_epi16( m4, 0 );
            dst[y*max_w+x+1].y  = _mm_extract_epi16( m4, 1 );
            dst[y*max_w+x+2].y  = _mm_extract_epi16( m4, 2 );
            dst[y*max_w+x+3].y  = _mm_extract_epi16( m4, 3 );
            x += 4;
        }
        // [2
        if( x < x_end - 1 )
        {
            __m128i m0 = _mm_cvtsi32_si128( MK_INT( src[(y-1)*max_w+x-1].y, src[(y-1)*max_w+x  ].y ) );
            __m128i m1 = _mm_cvtsi32_si128( MK_INT( src[(y-1)*max_w+x  ].y, src[(y-1)*max_w+x+1].y ) );
            __m128i m2 = _mm_cvtsi32_si128( MK_INT( src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y ) );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            dst[y*max_w+x+0].cb = src[y*max_w+x+0].cb;
            dst[y*max_w+x+0].cr = src[y*max_w+x+0].cr;
            dst[y*max_w+x+1].cb = src[y*max_w+x+1].cb;
            dst[y*max_w+x+1].cr = src[y*max_w+x+1].cr;
            __m128i m3 = _mm_cvtsi32_si128( MK_INT( src[y*max_w+x-1].y, src[y*max_w+x  ].y ) );
            __m128i m4 = _mm_cvtsi32_si128( MK_INT( src[y*max_w+x  ].y, src[y*max_w+x+1].y ) );
            __m128i m5 = _mm_cvtsi32_si128( MK_INT( src[y*max_w+x+1].y, src[y*max_w+x+2].y ) );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m6 = _mm_cvtsi32_si128( MK_INT( src[(y+1)*max_w+x-1].y, src[(y+1)*max_w+x  ].y ) );
            __m128i m7 = _mm_cvtsi32_si128( MK_INT( src[(y+1)*max_w+x  ].y, src[(y+1)*max_w+x+1].y ) );
            __m128i m8 = _mm_cvtsi32_si128( MK_INT( src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y ) );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );
            dst[y*max_w+x+0].y  = _mm_extract_epi16( m4, 0 );
            dst[y*max_w+x+1].y  = _mm_extract_epi16( m4, 1 );
            x += 2;
        }
        // [1
        if( x < x_end )
        {
            __m128i m0 = _mm_cvtsi32_si128( src[(y-1)*max_w+x-1].y );
            __m128i m1 = _mm_cvtsi32_si128( src[(y-1)*max_w+x  ].y );
            __m128i m2 = _mm_cvtsi32_si128( src[(y-1)*max_w+x+1].y );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            dst[y*max_w+x+0].cb = src[y*max_w+x+0].cb;
            dst[y*max_w+x+0].cr = src[y*max_w+x+0].cr;
            __m128i m3 = _mm_cvtsi32_si128( src[y*max_w+x-1].y );
            __m128i m4 = _mm_cvtsi32_si128( src[y*max_w+x  ].y );
            __m128i m5 = _mm_cvtsi32_si128( src[y*max_w+x+1].y );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m6 = _mm_cvtsi32_si128( src[(y+1)*max_w+x-1].y );
            __m128i m7 = _mm_cvtsi32_si128( src[(y+1)*max_w+x  ].y );
            __m128i m8 = _mm_cvtsi32_si128( src[(y+1)*max_w+x+1].y );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );
            dst[y*max_w+x+0].y  = _mm_extract_epi16( m4, 0 );
            x++;
        }

        // E[̂܂܃Rs[
        for( ; x < w; x++ ) dst[y*max_w+x] = src[y*max_w+x];
    }
}

//---------------------------------------------------------------------
// 8ߖTi3x3jŏXbh SSE2 F
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_8point_chroma_sse2( int thread_id, int thread_num, void *param1, void *param2 )
{
    const int *mask_table = (int *)param1;
    const FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Rs[
    int w      = fpip->w;
    int h      = fpip->h;
    int max_w  = fpip->max_w;

    // sȒl͒e
    if( h <= 0 || w <= 0 || max_w <= 0 || thread_num <= 0 ) return;

    // Xbhc̃TCY葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num || thread_id < 0 ) return;

    // Xbh̉摜郉CvZ
    const int y_start = (h *  thread_id     ) / thread_num;
    const int y_end   = (h * (thread_id + 1)) / thread_num;

    // ㉺̃}XN͈
    int mask_top    = mask_table[MASK_TOP];
    int mask_bottom = mask_table[MASK_BOTTOM];
    if( mask_top    <= 0  ) mask_top    = 1; // ʂ̗[͏Ȃ
    if( mask_bottom <= 0 ) mask_bottom = 1;  // 

    // Ȅ͈͂vZ
    int x_start = 0 + mask_table[MASK_LEFT];
    int x_end   = w - mask_table[MASK_RIGHT];
    if( x_start <= 0 ) x_start = 1; // ʂ̗[͏Ȃ
    if( x_end > w-1 ) x_end = w-1;  // 

    // short^Pʂł̂3{
    x_start *= 3;
    x_end   *= 3;
    w       *= 3;
    max_w   *= 3;

    // |C^ishort^Ɂj
    const short *__restrict__ src = (short *)fpip->ycp_edit;
          short *__restrict__ dst = (short *)fpip->ycp_temp;

    for( int y = y_start; y < y_end; y++ )
    {
        // }XN̈͂̂܂܃Rs[
        if( y < mask_top || y >= h - mask_bottom )
        {
            memcpy( dst + y*max_w, src + y*max_w, w*sizeof(src[0]) );
            continue;
        }

        int x = 0;

        // [̂܂܃Rs[
        for( ; x<x_start; x++ ) dst[y*max_w+x] = src[y*max_w+x];

#ifdef USE_MOVNT
        // o͑|C^16byteACgɍ킹
        // paddingshort^(2byte)P  xKvB
        int padding = ( - (unsigned int)&dst[y*max_w+x] ) & 0xF;
        if( (x_end-x_start) > 15 && !(padding & 0x1) )
        {
#ifdef USE_PREFETCH
            _mm_prefetch( &src[(y+2)*max_w+x], PREFETCH_HINT ); // ̃CvtFb`
#endif
            if( padding & 0x2 ) // shrot^1
            {
                __m128i m0 = _mm_cvtsi32_si128( src[(y-1)*max_w+x-3] );
                __m128i m1 = _mm_cvtsi32_si128( src[(y-1)*max_w+x  ] );
                __m128i m2 = _mm_cvtsi32_si128( src[(y-1)*max_w+x+3] );
                MIN_MAX_SSE2( m0, m1 );
                MIN_MAX_SSE2( m1, m2 );
                MIN_MAX_SSE2( m0, m1 );
                __m128i m3 = _mm_cvtsi32_si128( src[y*max_w+x-3] );
                __m128i m4 = _mm_cvtsi32_si128( src[y*max_w+x  ] );
                __m128i m5 = _mm_cvtsi32_si128( src[y*max_w+x+3] );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m4, m5 );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m0, m3 );
                MIN_MAX_SSE2( m2, m5 );
                MIN_MAX_SSE2( m1, m4 );
                __m128i m6 = _mm_cvtsi32_si128( src[(y+1)*max_w+x-3] );
                __m128i m7 = _mm_cvtsi32_si128( src[(y+1)*max_w+x  ] );
                __m128i m8 = _mm_cvtsi32_si128( src[(y+1)*max_w+x+3] );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m7, m8 );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m3, m6 );
                MIN_MAX_SSE2( m2, m8 );
                MIN_MAX_SSE2( m4, m7 );
                MIN_MAX_SSE2( m1, m4 );
                MIN_MAX_SSE2( m2, m4 );
                MIN_MAX_SSE2( m4, m6 );
                MIN_MAX_SSE2( m2, m4 );
                dst[y*max_w+x+0] = _mm_extract_epi16( m4, 0 );
                x++;
            }
            if( padding & 0x4 ) // shrot^2
            {
                __m128i m0 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x-3] );
                __m128i m1 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x  ] );
                __m128i m2 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x+3] );
                MIN_MAX_SSE2( m0, m1 );
                MIN_MAX_SSE2( m1, m2 );
                MIN_MAX_SSE2( m0, m1 );
                __m128i m3 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x-3] );
                __m128i m4 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x  ] );
                __m128i m5 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x+3] );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m4, m5 );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m0, m3 );
                MIN_MAX_SSE2( m2, m5 );
                MIN_MAX_SSE2( m1, m4 );
                __m128i m6 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x-3] );
                __m128i m7 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x  ] );
                __m128i m8 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x+3] );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m7, m8 );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m3, m6 );
                MIN_MAX_SSE2( m2, m8 );
                MIN_MAX_SSE2( m4, m7 );
                MIN_MAX_SSE2( m1, m4 );
                MIN_MAX_SSE2( m2, m4 );
                MIN_MAX_SSE2( m4, m6 );
                MIN_MAX_SSE2( m2, m4 );
                dst[y*max_w+x+0] = _mm_extract_epi16( m4, 0 );
                dst[y*max_w+x+1] = _mm_extract_epi16( m4, 1 );
                x += 2;
            }
            if( padding & 0x8 ) // shrot^4
            {
                __m128i m0 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x-3] );
                __m128i m1 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x  ] );
                __m128i m2 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x+3] );
                MIN_MAX_SSE2( m0, m1 );
                MIN_MAX_SSE2( m1, m2 );
                MIN_MAX_SSE2( m0, m1 );
                __m128i m3 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x-3] );
                __m128i m4 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x  ] );
                __m128i m5 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x+3] );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m4, m5 );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m0, m3 );
                MIN_MAX_SSE2( m2, m5 );
                MIN_MAX_SSE2( m1, m4 );
                __m128i m6 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x-3] );
                __m128i m7 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x  ] );
                __m128i m8 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x+3] );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m7, m8 );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m3, m6 );
                MIN_MAX_SSE2( m2, m8 );
                MIN_MAX_SSE2( m4, m7 );
                MIN_MAX_SSE2( m1, m4 );
                MIN_MAX_SSE2( m2, m4 );
                MIN_MAX_SSE2( m4, m6 );
                MIN_MAX_SSE2( m2, m4 );
                _mm_storel_epi64( (__m128i *)&dst[y*max_w+x], m4 );
                x += 4;
            }

            // ACg
            // SSE28
            for( ; x < x_end - 7; x += 8 )
            {
                __m128i m0 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+x-3] );
                __m128i m1 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+x  ] );
                __m128i m2 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+x+3] );
                MIN_MAX_SSE2( m0, m1 );
                MIN_MAX_SSE2( m1, m2 );
                MIN_MAX_SSE2( m0, m1 );
                __m128i m3 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x-3] );
                __m128i m4 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x  ] );
                __m128i m5 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+3] );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m4, m5 );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m0, m3 );
                MIN_MAX_SSE2( m2, m5 );
                MIN_MAX_SSE2( m1, m4 );
                __m128i m6 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+x-3] );
                __m128i m7 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+x  ] );
                __m128i m8 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+x+3] );
#ifdef USE_PREFETCH
                _mm_prefetch( &src[(y+2)*max_w+x], PREFETCH_HINT ); // ̃CvtFb`
#endif
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m7, m8 );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m3, m6 );
                MIN_MAX_SSE2( m2, m8 );
                MIN_MAX_SSE2( m4, m7 );
                MIN_MAX_SSE2( m1, m4 );
                MIN_MAX_SSE2( m2, m4 );
                MIN_MAX_SSE2( m4, m6 );
                MIN_MAX_SSE2( m2, m4 );
                // Xg[~Oo
                _mm_stream_si128( (__m128i *)&dst[y*max_w+x], m4 );
            }
        }
        else
#endif
        {
            // ACg낦Ȃ
            // SSE28
            for( ; x < x_end - 7; x += 8 )
            {
                __m128i m0 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+x-3] );
                __m128i m1 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+x  ] );
                __m128i m2 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+x+3] );
                MIN_MAX_SSE2( m0, m1 );
                MIN_MAX_SSE2( m1, m2 );
                MIN_MAX_SSE2( m0, m1 );
                __m128i m3 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x-3] );
                __m128i m4 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x  ] );
                __m128i m5 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+3] );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m4, m5 );
                MIN_MAX_SSE2( m3, m4 );
                MIN_MAX_SSE2( m0, m3 );
                MIN_MAX_SSE2( m2, m5 );
                MIN_MAX_SSE2( m1, m4 );
                __m128i m6 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+x-3] );
                __m128i m7 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+x  ] );
                __m128i m8 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+x+3] );
#ifdef USE_PREFETCH
                _mm_prefetch( &src[(y+2)*max_w+x], PREFETCH_HINT ); // ̃CvtFb`
#endif
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m7, m8 );
                MIN_MAX_SSE2( m6, m7 );
                MIN_MAX_SSE2( m3, m6 );
                MIN_MAX_SSE2( m2, m8 );
                MIN_MAX_SSE2( m4, m7 );
                MIN_MAX_SSE2( m1, m4 );
                MIN_MAX_SSE2( m2, m4 );
                MIN_MAX_SSE2( m4, m6 );
                MIN_MAX_SSE2( m2, m4 );
                _mm_storeu_si128( (__m128i *)&dst[y*max_w+x], m4 );
            }
        }

        // [4
        if( x < x_end - 3 )
        {
            __m128i m0 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x-3] );
            __m128i m1 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x  ] );
            __m128i m2 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x+3] );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            __m128i m3 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x-3] );
            __m128i m4 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x  ] );
            __m128i m5 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x+3] );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m6 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x-3] );
            __m128i m7 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x  ] );
            __m128i m8 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x+3] );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );
            _mm_storel_epi64( (__m128i *)&dst[y*max_w+x], m4 );
            x += 4;
        }
        // [2
        if( x < x_end - 1 )
        {
            __m128i m0 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x-3] );
            __m128i m1 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x  ] );
            __m128i m2 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x+3] );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            __m128i m3 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x-3] );
            __m128i m4 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x  ] );
            __m128i m5 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x+3] );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m6 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x-3] );
            __m128i m7 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x  ] );
            __m128i m8 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x+3] );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );
            dst[y*max_w+x+0] = _mm_extract_epi16( m4, 0 );
            dst[y*max_w+x+1] = _mm_extract_epi16( m4, 1 );
            x += 2;
        }
        // [1
        if( x < x_end )
        {
            __m128i m0 = _mm_cvtsi32_si128( src[(y-1)*max_w+x-3] );
            __m128i m1 = _mm_cvtsi32_si128( src[(y-1)*max_w+x  ] );
            __m128i m2 = _mm_cvtsi32_si128( src[(y-1)*max_w+x+3] );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            __m128i m3 = _mm_cvtsi32_si128( src[y*max_w+x-3] );
            __m128i m4 = _mm_cvtsi32_si128( src[y*max_w+x  ] );
            __m128i m5 = _mm_cvtsi32_si128( src[y*max_w+x+3] );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m6 = _mm_cvtsi32_si128( src[(y+1)*max_w+x-3] );
            __m128i m7 = _mm_cvtsi32_si128( src[(y+1)*max_w+x  ] );
            __m128i m8 = _mm_cvtsi32_si128( src[(y+1)*max_w+x+3] );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );
            dst[y*max_w+x+0] = _mm_extract_epi16( m4, 0 );
            x++;
        }

        // E[̂܂܃Rs[
        for( ; x < w; x++ ) dst[y*max_w+x] = src[y*max_w+x];
    }
}

//---------------------------------------------------------------------
// 4ߖTŏXbh SSE2
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_4point_sse2( int thread_id, int thread_num, void *param1, void *param2 )
{
    const int *mask_table = (int *)param1;
    const FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Rs[
    const int w      = fpip->w;
    const int h      = fpip->h;
    const int max_w  = fpip->max_w;

    // sȒl͒e
    if( h <= 0 || w <= 0 || max_w <= 0 || thread_num <= 0 ) return;

    // Xbhc葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num || thread_id < 0 ) return;

    // Xbh̃CvZ
    int y_start = (h *  thread_id     ) / thread_num;
    int y_end   = (h * (thread_id + 1)) / thread_num;

    // ㉺̃}XN͈
    int mask_top    = mask_table[MASK_TOP];
    int mask_bottom = mask_table[MASK_BOTTOM];
    if( mask_top    <= 0  ) mask_top    = 1; // ʂ̗[͏Ȃ
    if( mask_bottom <= 0 ) mask_bottom = 1;  // 

    // Ȅ͈͂vZ
    int x_start = 0 + mask_table[MASK_LEFT];
    int x_end   = w - mask_table[MASK_RIGHT];
    if( x_start <= 0 ) x_start = 1; // ʂ̗[͏Ȃ
    if( x_end > w-1 ) x_end = w-1;  // 

    // |C^
    const PIXEL_YC *__restrict__ src = fpip->ycp_edit;
          PIXEL_YC *__restrict__ dst = fpip->ycp_temp;

    for( int y = y_start; y < y_end; y++ )
    {
        // }XN̈͂̂܂܃Rs[
        if( y < mask_top || y >= h - mask_bottom )
        {
            my_memcpy( dst + y*max_w, src + y*max_w, w*sizeof(src[0]) );
            continue;
        }

        int x = 0;

        // [̂܂܃Rs[
        for( ; x<x_start; x++ ) dst[y*max_w+x] = src[y*max_w+x];

#ifdef USE_MOVNT
        // o͑|C^16byteACgɍ킹
        // paddingshort^(2byte)P  xKvB
        int padding = ( - (unsigned int)&dst[y*max_w+x] ) & 0xF;
        if( (x_end-x_start) > 15 && !(padding & 0x1) )
        {
            padding = ((padding>>1)*3) & 0x7; // ̂ɕKvYC48̐

#ifdef USE_PREFETCH
            _mm_prefetch( &src[(y+2)*max_w+x].y, PREFETCH_HINT ); // ̃CvtFb`
#endif

            if( padding & 0x1 ) // YC48 1
            {
                __m128i m3 = _mm_cvtsi32_si128( src[(y-1)*max_w+x].y );
                dst[y*max_w+x].cb = src[y*max_w+x].cb;
                dst[y*max_w+x].cr = src[y*max_w+x].cr;
                __m128i m0 = _mm_cvtsi32_si128( src[y*max_w+x-1].y );
                __m128i m1 = _mm_cvtsi32_si128( src[y*max_w+x  ].y );
                __m128i m2 = _mm_cvtsi32_si128( src[y*max_w+x+1].y );
                __m128i m4 = _mm_cvtsi32_si128( src[(y+1)*max_w+x].y );
                FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
                dst[y*max_w+x].y  = _mm_extract_epi16( m2, 0 );
                x++;
            }
            if( padding & 0x2 ) // YC48 2
            {
                __m128i m3 = _mm_cvtsi32_si128( MK_INT( src[(y-1)*max_w+x+0].y, src[(y-1)*max_w+x+1].y ) );
                __m128i m0 = _mm_cvtsi32_si128( MK_INT( src[y*max_w+x-1].y, src[y*max_w+x+0].y ) );
                __m128i m1 = _mm_cvtsi32_si128( MK_INT( src[y*max_w+x+0].y, src[y*max_w+x+1].y ) );
                __m128i m2 = _mm_cvtsi32_si128( MK_INT( src[y*max_w+x+1].y, src[y*max_w+x+2].y ) );
                __m128i m4 = _mm_cvtsi32_si128( MK_INT( src[(y+1)*max_w+x+0].y, src[(y+1)*max_w+x+1].y ) );
                FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
                // 32bit(4byte)Xg[~Oo
                _mm_stream_si32( (int *)&dst[y*max_w+x+0].y , MK_INT( _mm_extract_epi16( m2, 0 ), src[y*max_w+x+0].cb ) );
                _mm_stream_si32( (int *)&dst[y*max_w+x+0].cr, MK_INT( src[y*max_w+x+0].cr, _mm_extract_epi16( m2, 1 ) ) );
                _mm_stream_si32( (int *)&dst[y*max_w+x+1].cb, MK_INT( src[y*max_w+x+1].cb, src[y*max_w+x+1].cr ) );
                x += 2;
            }
            if( padding & 0x4 ) // YC48 4
            {
                __m128i m0, m1, m2, m3, m4;
                MK_M128I_S4( m3, src[(y-1)*max_w+x+0].y, src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y, src[(y-1)*max_w+x+3].y );
                MK_M128I_S4( m0, src[y*max_w+x-1].y, src[y*max_w+x+0].y, src[y*max_w+x+1].y, src[y*max_w+x+2].y );
                m1 = _mm_insert_epi16( _mm_srli_si128( m0, 16/8 ), src[y*max_w+x+3].y, 3 );
                m2 = _mm_insert_epi16( _mm_srli_si128( m1, 16/8 ), src[y*max_w+x+4].y, 3 );
                MK_M128I_S4( m4, src[(y+1)*max_w+x+0].y, src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y, src[(y+1)*max_w+x+3].y );
                FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
                // 32bit(4byte)Xg[~Oo
                _mm_stream_si32( (int *)&dst[y*max_w+x+0].y , MK_INT( _mm_extract_epi16( m2, 0 ), src[y*max_w+x+0].cb ) );
                _mm_stream_si32( (int *)&dst[y*max_w+x+0].cr, MK_INT( src[y*max_w+x+0].cr, _mm_extract_epi16( m2, 1 ) ) );
                // 16byteACɑĂ
                __m128i out0 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+1].cb );
                out0 = _mm_insert_epi16( out0, _mm_extract_epi16( m2, 2 ), 2 );
                out0 = _mm_insert_epi16( out0, _mm_extract_epi16( m2, 3 ), 5 );
                _mm_stream_si128( (__m128i *)&dst[y*max_w+x+1].cb, out0 );
                x += 4;
            }

            // o͑̃ACg
            // SSE28
            for( ; x < x_end - 7; x += 8 )
            {
                __m128i m0, m1, m2, m3, m4;

                MK_M128I_S8( m3, src[(y-1)*max_w+x+0].y, src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y, src[(y-1)*max_w+x+3].y, src[(y-1)*max_w+x+4].y, src[(y-1)*max_w+x+5].y, src[(y-1)*max_w+x+6].y, src[(y-1)*max_w+x+7].y );
                MK_M128I_S8( m1, src[y*max_w+x+0].y, src[y*max_w+x+1].y, src[y*max_w+x+2].y, src[y*max_w+x+3].y, src[y*max_w+x+4].y, src[y*max_w+x+5].y, src[y*max_w+x+6].y, src[y*max_w+x+7].y );
                m0 = _mm_insert_epi16( _mm_slli_si128( m1, 16/8 ), src[y*max_w+x-1].y, 0 );
                m2 = _mm_insert_epi16( _mm_srli_si128( m1, 16/8 ), src[y*max_w+x+8].y, 7 );
                MK_M128I_S8( m4, src[(y+1)*max_w+x+0].y, src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y, src[(y+1)*max_w+x+3].y, src[(y+1)*max_w+x+4].y, src[(y+1)*max_w+x+5].y, src[(y+1)*max_w+x+6].y, src[(y+1)*max_w+x+7].y );
#ifdef USE_PREFETCH
                _mm_prefetch( &src[(y+2)*max_w+x].y, PREFETCH_HINT ); // ̃CvtFb`
#endif
                FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );

                // m2lifBAj
                __m128i out0 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+0].y  );
                __m128i out1 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+2].cr );
                __m128i out2 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+5].cb );
                out0 = _mm_insert_epi16( out0, _mm_extract_epi16( m2, 0 ), 0 );
                out0 = _mm_insert_epi16( out0, _mm_extract_epi16( m2, 1 ), 3 );
                out0 = _mm_insert_epi16( out0, _mm_extract_epi16( m2, 2 ), 6 );
                out1 = _mm_insert_epi16( out1, _mm_extract_epi16( m2, 3 ), 1 );
                out1 = _mm_insert_epi16( out1, _mm_extract_epi16( m2, 4 ), 4 );
                out1 = _mm_insert_epi16( out1, _mm_extract_epi16( m2, 5 ), 7 );
                out2 = _mm_insert_epi16( out2, _mm_extract_epi16( m2, 6 ), 2 );
                out2 = _mm_insert_epi16( out2, _mm_extract_epi16( m2, 7 ), 5 );
                // Xg[~Oo
                _mm_stream_si128( (__m128i *)&dst[y*max_w+x+0].y , out0 );
                _mm_stream_si128( (__m128i *)&dst[y*max_w+x+2].cr, out1 );
                _mm_stream_si128( (__m128i *)&dst[y*max_w+x+5].cb, out2 );
            }
        }
        else
#endif
        {
            // ACgȂ
            // SSE28
            for( ; x < x_end - 7; x += 8 )
            {
                // FiPx܂Ƃ߂ājRs[
                _mm_storeu_si128( (__m128i *)&dst[y*max_w+x+0].y , _mm_loadu_si128( (__m128i *)&src[y*max_w+x+0].y  ) );
                _mm_storeu_si128( (__m128i *)&dst[y*max_w+x+2].cr, _mm_loadu_si128( (__m128i *)&src[y*max_w+x+2].cr ) );
                _mm_storeu_si128( (__m128i *)&dst[y*max_w+x+5].cb, _mm_loadu_si128( (__m128i *)&src[y*max_w+x+5].cb ) );

                __m128i m0, m1, m2, m3, m4;
                MK_M128I_S8( m3, src[(y-1)*max_w+x+0].y, src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y, src[(y-1)*max_w+x+3].y, src[(y-1)*max_w+x+4].y, src[(y-1)*max_w+x+5].y, src[(y-1)*max_w+x+6].y, src[(y-1)*max_w+x+7].y );
                MK_M128I_S8( m1, src[y*max_w+x+0].y, src[y*max_w+x+1].y, src[y*max_w+x+2].y, src[y*max_w+x+3].y, src[y*max_w+x+4].y, src[y*max_w+x+5].y, src[y*max_w+x+6].y, src[y*max_w+x+7].y );
                m0 = _mm_insert_epi16( _mm_slli_si128( m1, 16/8 ), src[y*max_w+x-1].y, 0 );
                m2 = _mm_insert_epi16( _mm_srli_si128( m1, 16/8 ), src[y*max_w+x+8].y, 7 );
                MK_M128I_S8( m4, src[(y+1)*max_w+x+0].y, src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y, src[(y+1)*max_w+x+3].y, src[(y+1)*max_w+x+4].y, src[(y+1)*max_w+x+5].y, src[(y+1)*max_w+x+6].y, src[(y+1)*max_w+x+7].y );
#ifdef USE_PREFETCH
                _mm_prefetch( &src[(y+2)*max_w+x].y, PREFETCH_HINT ); // ̃CvtFb`
#endif
                FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
                // m2lifBAj
                dst[y*max_w+x+0].y  = _mm_extract_epi16( m2, 0 );
                dst[y*max_w+x+1].y  = _mm_extract_epi16( m2, 1 );
                dst[y*max_w+x+2].y  = _mm_extract_epi16( m2, 2 );
                dst[y*max_w+x+3].y  = _mm_extract_epi16( m2, 3 );
                dst[y*max_w+x+4].y  = _mm_extract_epi16( m2, 4 );
                dst[y*max_w+x+5].y  = _mm_extract_epi16( m2, 5 );
                dst[y*max_w+x+6].y  = _mm_extract_epi16( m2, 6 );
                dst[y*max_w+x+7].y  = _mm_extract_epi16( m2, 7 );
            }
        }

        // [4
        if( x < x_end - 3 )
        {
            __m128i m0, m1, m2, m3, m4;
            MK_M128I_S4( m3, src[(y-1)*max_w+x+0].y, src[(y-1)*max_w+x+1].y, src[(y-1)*max_w+x+2].y, src[(y-1)*max_w+x+3].y );
            MK_M128I_S4( m0, src[y*max_w+x-1].y, src[y*max_w+x+0].y, src[y*max_w+x+1].y, src[y*max_w+x+2].y );
            m1 = _mm_insert_epi16( _mm_srli_si128( m0, 16/8 ), src[y*max_w+x+3].y, 3 );
            m2 = _mm_insert_epi16( _mm_srli_si128( m1, 16/8 ), src[y*max_w+x+4].y, 3 );
            MK_M128I_S4( m4, src[(y+1)*max_w+x+0].y, src[(y+1)*max_w+x+1].y, src[(y+1)*max_w+x+2].y, src[(y+1)*max_w+x+3].y );
            FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
            dst[y*max_w+x+0].y  = _mm_extract_epi16( m2, 0 );
            dst[y*max_w+x+0].cb = src[y*max_w+x+0].cb;
            dst[y*max_w+x+0].cr = src[y*max_w+x+0].cr;
            dst[y*max_w+x+1].y  = _mm_extract_epi16( m2, 1 );
            dst[y*max_w+x+1].cb = src[y*max_w+x+1].cb;
            dst[y*max_w+x+1].cr = src[y*max_w+x+1].cr;
            dst[y*max_w+x+2].y  = _mm_extract_epi16( m2, 2 );
            dst[y*max_w+x+2].cb = src[y*max_w+x+2].cb;
            dst[y*max_w+x+2].cr = src[y*max_w+x+2].cr;
            dst[y*max_w+x+3].y  = _mm_extract_epi16( m2, 3 );
            dst[y*max_w+x+3].cb = src[y*max_w+x+3].cb;
            dst[y*max_w+x+3].cr = src[y*max_w+x+3].cr;
            x += 4;
        }
        // [2
        if( x < x_end - 1 )
        {
            __m128i m3 = _mm_cvtsi32_si128( MK_INT( src[(y-1)*max_w+x+0].y, src[(y-1)*max_w+x+1].y ) );
            __m128i m0 = _mm_cvtsi32_si128( MK_INT( src[y*max_w+x-1].y, src[y*max_w+x+0].y ) );
            __m128i m1 = _mm_cvtsi32_si128( MK_INT( src[y*max_w+x+0].y, src[y*max_w+x+1].y ) );
            __m128i m2 = _mm_cvtsi32_si128( MK_INT( src[y*max_w+x+1].y, src[y*max_w+x+2].y ) );
            __m128i m4 = _mm_cvtsi32_si128( MK_INT( src[(y+1)*max_w+x+0].y, src[(y+1)*max_w+x+1].y ) );
            FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
            dst[y*max_w+x+0].y  = _mm_extract_epi16( m2, 0 );
            dst[y*max_w+x+0].cb = src[y*max_w+x+0].cb;
            dst[y*max_w+x+0].cr = src[y*max_w+x+0].cr;
            dst[y*max_w+x+1].y  = _mm_extract_epi16( m2, 1 );
            dst[y*max_w+x+1].cb = src[y*max_w+x+1].cb;
            dst[y*max_w+x+1].cr = src[y*max_w+x+1].cr;
            x += 2;
        }
        // [1
        if( x < x_end )
        {
            __m128i m3 = _mm_cvtsi32_si128( src[(y-1)*max_w+x].y );
            __m128i m0 = _mm_cvtsi32_si128( src[y*max_w+x-1].y );
            __m128i m1 = _mm_cvtsi32_si128( src[y*max_w+x  ].y );
            __m128i m2 = _mm_cvtsi32_si128( src[y*max_w+x+1].y );
            __m128i m4 = _mm_cvtsi32_si128( src[(y+1)*max_w+x].y );
            FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
            dst[y*max_w+x].y  = _mm_extract_epi16( m2, 0 );
            dst[y*max_w+x].cb = src[y*max_w+x].cb;
            dst[y*max_w+x].cr = src[y*max_w+x].cr;
            x++;
        }

        // E[̂܂܃Rs[
        for(; x < w; x++ ) dst[y*max_w+x] = src[y*max_w+x];
    }
}

//---------------------------------------------------------------------
// 4ߖTŏXbh SSE2 F
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_4point_chroma_sse2( int thread_id, int thread_num, void *param1, void *param2 )
{
    const int *mask_table = (int *)param1;
    const FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Rs[
    int w      = fpip->w;
    int h      = fpip->h;
    int max_w  = fpip->max_w;

    // sȒl͒e
    if( h <= 0 || w <= 0 || max_w <= 0 || thread_num <= 0 ) return;

    // Xbhc葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num || thread_id < 0 ) return;

    // Xbh̃CvZ
    int y_start = (h *  thread_id     ) / thread_num;
    int y_end   = (h * (thread_id + 1)) / thread_num;

    // ㉺̃}XN͈
    int mask_top    = mask_table[MASK_TOP];
    int mask_bottom = mask_table[MASK_BOTTOM];
    if( mask_top    <= 0  ) mask_top    = 1; // ʂ̗[͏Ȃ
    if( mask_bottom <= 0 ) mask_bottom = 1;  // 

    // Ȅ͈͂vZ
    int x_start = 0 + mask_table[MASK_LEFT];
    int x_end   = w - mask_table[MASK_RIGHT];
    if( x_start <= 0 ) x_start = 1; // ʂ̗[͏Ȃ
    if( x_end > w-1 ) x_end = w-1;  // 

    // short^Pʂł̂3{
    x_start *= 3;
    x_end   *= 3;
    w       *= 3;
    max_w   *= 3;

    // |C^ishort^Ɂj
    const short *__restrict__ src = (short *)fpip->ycp_edit;
          short *__restrict__ dst = (short *)fpip->ycp_temp;

    for( int y = y_start; y < y_end; y++ )
    {
        // }XN̈͂̂܂܃Rs[
        if( y < mask_top || y >= h - mask_bottom )
        {
            my_memcpy( dst + y*max_w, src + y*max_w, w*sizeof(src[0]) );
            continue;
        }

        int x = 0;

        // [̂܂܃Rs[
        for( ; x<x_start; x++ ) dst[y*max_w+x] = src[y*max_w+x];

#ifdef USE_MOVNT
        // o͑|C^16byteACgɍ킹
        // paddingshort^(2byte)P  xKvB
        int padding = ( - (unsigned int)&dst[y*max_w+x] ) & 0xF;
        if( (x_end-x_start) > 15 && !(padding & 0x1) )
        {
#ifdef USE_PREFETCH
            _mm_prefetch( &src[(y+2)*max_w+x], PREFETCH_HINT ); // ̃CvtFb`
#endif
            if( padding & 0x2 ) // shrot^1
            {
                __m128i m0 = _mm_cvtsi32_si128( src[(y-1)*max_w+x ] );
                __m128i m1 = _mm_cvtsi32_si128( src[y*max_w+x-3] );
                __m128i m2 = _mm_cvtsi32_si128( src[y*max_w+x+0] );
                __m128i m3 = _mm_cvtsi32_si128( src[y*max_w+x+3] );
                __m128i m4 = _mm_cvtsi32_si128( src[(y+1)*max_w+x ] );
                FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
                dst[y*max_w+x] = _mm_extract_epi16( m2, 0 );
                x++;
            }
            if( padding & 0x4 ) // shrot^2
            {
                __m128i m0 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x ] );
                __m128i m1 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x-3] );
                __m128i m2 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x+0] );
                __m128i m3 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x+3] );
                __m128i m4 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x ] );
                FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
                dst[y*max_w+x+0] = _mm_extract_epi16( m2, 0 );
                dst[y*max_w+x+1] = _mm_extract_epi16( m2, 1 );
                x += 2;
            }
            if( padding & 0x8 ) // shrot^4
            {
                __m128i m0 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x  ] );
                __m128i m1 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x-3] );
                __m128i m2 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x  ] );
                __m128i m3 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x+3] );
                __m128i m4 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x  ] );
                FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
                _mm_storel_epi64( (__m128i *)&dst[y*max_w+x], m2 );
                x += 4;
            }

            // o͑̃ACg
            // SSE28
            for( ; x < x_end - 7; x += 8 )
            {
                __m128i m0 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+x  ] );
                __m128i m1 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x-3] );
                __m128i m2 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x  ] );
                __m128i m3 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+3] );
                __m128i m4 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+x  ] );
#ifdef USE_PREFETCH
                _mm_prefetch( &src[(y+2)*max_w+x], PREFETCH_HINT ); // ̃CvtFb`
#endif
                FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
                // Xg[~Oo
                _mm_stream_si128( (__m128i *)&dst[y*max_w+x], m2 );
            }
        }
        else
#endif
        {
            // ACgȂ
            // SSE28
            for( ; x < x_end - 7; x += 8 )
            {
                __m128i m0 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+x  ] );
                __m128i m1 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x-3] );
                __m128i m2 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x  ] );
                __m128i m3 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+3] );
                __m128i m4 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+x  ] );
#ifdef USE_PREFETCH
                _mm_prefetch( &src[(y+2)*max_w+x], PREFETCH_HINT ); // ̃CvtFb`
#endif
                FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
                _mm_storeu_si128( (__m128i *)&dst[y*max_w+x], m2 );
            }
        }

        // [4
        if( x < x_end - 3 )
        {
            __m128i m0 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x  ] );
            __m128i m1 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x-3] );
            __m128i m2 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x  ] );
            __m128i m3 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x+3] );
            __m128i m4 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x  ] );
            FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
            _mm_storel_epi64( (__m128i *)&dst[y*max_w+x], m2 );
            x += 4;
        }
        // [2
        if( x < x_end - 1 )
        {
            __m128i m0 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x ] );
            __m128i m1 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x-3] );
            __m128i m2 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x+0] );
            __m128i m3 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x+3] );
            __m128i m4 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x ] );
            FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
            dst[y*max_w+x+0] = _mm_extract_epi16( m2, 0 );
            dst[y*max_w+x+1] = _mm_extract_epi16( m2, 1 );
            x += 2;
        }
        // [1
        if( x < x_end )
        {
            __m128i m0 = _mm_cvtsi32_si128( src[(y-1)*max_w+x ] );
            __m128i m1 = _mm_cvtsi32_si128( src[y*max_w+x-3] );
            __m128i m2 = _mm_cvtsi32_si128( src[y*max_w+x+0] );
            __m128i m3 = _mm_cvtsi32_si128( src[y*max_w+x+3] );
            __m128i m4 = _mm_cvtsi32_si128( src[(y+1)*max_w+x ] );
            FIND_MEDIUM_FIVE( m0, m1, m2, m3, m4 );
            dst[y*max_w+x] = _mm_extract_epi16( m2, 0 );
            x++;
        }

        // E[̂܂܃Rs[
        for(; x < w; x++ ) dst[y*max_w+x] = src[y*max_w+x];
    }
}
